/*
 * file.i.o.c
 * Copyright (C) 2008, 2009, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <unistd.h>

#include <sys/types.h>

#include <file-defs.h>
#include <file-types.h>

#define file(file) \
    ((struct eifile_type *) (file))

int
_libx1f4i0_seek_ifile(void *file, off_t offset, int whence)
{
    int status;

    do {
	if (whence == SEEK_CUR) {
	    unsigned miss;

	    miss = file(file)->size;
	    if (miss) {
		if (offset < (off_t) 0) {
		    offset -= miss;
		} else {
		    if ((off_t) miss < offset) {
			offset -= miss;
		    } else {
			status = 0;

			file(file)->ever += offset;
			file(file)->size -= offset;

			break;
		    }
		}
	    }
	}

	file(file)->size = 0;

	status = file(file)->sf->seek(&file(file)->sd, offset, whence);
	if (status == -1) {
	    status = SEEK_CLASS;
	} else {
	    status = 0;
	}
    } while (0);

    return status;
}
