/*
 * lxcall-t.j.c
 * Copyright (C) 2011, 2013, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <exerrors.h>
#include <frame.h>
#include <lxcall-inter.h>
#include <track.h>
#include <trans.h>

#define l_TEXT(e, output) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

extern const char *const x1f4_c1_empty_string;

int
_libx1f4i0_lxcall_swap_text(struct x1f4_frame_type *frame_data,
			    struct x1f4_trans_type *trans_data, 
			    struct x1f4_track_type *track_data, void *data,
			    void *text, unsigned size)
{
    int status;

    if (size ^ 1) {
	void *swap;

	status = trans_data->link(trans_data->data, &swap, size);
	if (status) {
	    status = _libx1f4i0_lxcall_stat_link(track_data);
	} else {
	    status = _libx1f4i0_lxcall_pick_text
		(frame_data, trans_data, track_data, data);
	    if (status) {
		trans_data->free(trans_data->data, swap);
	    } else {
		l_TEXT(swap, data);

		memcpy(swap, text, size);
	    }
	}
    } else {
	status = _libx1f4i0_lxcall_pick_text
	    (frame_data, trans_data, track_data, data);
	if (status) {
	} else {
	    l_TEXT((char *) x1f4_c1_empty_string, data);
	}
    }

    return status;
}
