/*
 * lxdash-a.0.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * TODO
 *
 * merge copy_line into fast_line
 */

#include <stddef.h>
#include <string.h>

#include <af.h>
#include <e4-m.0.h>
#include <e4.h>
#include <e4fine.h>
#include <lxcall.h>
#include <lxdash-defs.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>
#include <mxdeck.h>

#define MAKE_SINGLE(a, b)		a

#define may_include(lxtype)		0

#define l_e_type_post			3

#define l_g_type_post			3

#define l_i_type_post			3

#define lbe_type_post			2

#define lbg_type_post			2

#define lfe_type_post			2

#define lfg_type_post			2

#define true(e)				1

#define part(screen) \
    ((struct part_type *) (screen))
#define screen(screen) \
    (((struct part_type *) (screen))->screen_data)

#define fb_size()			2

#define fm_size(none) \
    sizeof(struct lxmiss_type)

typedef struct part_type {
    const struct screen_type *screen_data;
    struct x1f4_ftaa_type *ftaa_data;
    struct x1f4_ftca_type *ftca_data;
} part_type;

extern const struct x1f4_eelookup_type _x1f4_type_lookup;

static int init_line(struct lxdash_type *, unsigned,
		     const struct screen_type *);
static int line_data(struct lxdash_type *, unsigned, const struct part_type *,
		     void *, void *, void **, void **);
static int line_line(struct lxdash_type *, unsigned,
		     const struct screen_type *);
static int line_sail(struct lxdash_type *, const struct screen_type *,
		     struct x1f4_linetext_type **, struct lxtext_type *,
		     const struct lxtype_type *, void **, void **);
static int line_text(struct lxdash_type *, unsigned, const struct part_type *,
		     void *, void **, void **);
static int link_line(struct lxdash_type *, unsigned,
		     const struct screen_type *);
static int pick_miss(unsigned *, unsigned *, unsigned *, unsigned,
		     const struct screen_type *);

static void _slmmx00x(u_case_args_____0);
static void bo_lmm00x(u_case_args_____0);
static void bo_slmx00(u_case_args_____0);
static void born_lm0x(u_case_args_____0);
static void born_n_lm(v_case_args_____0);
static void borne_lmc(u_case_args_____0);
static void borne_lmm(u_case_args_____0);
static void borneo__l(u_case_args_____0);
static void borneo_l_(u_case_args_____0);
static void borneo_ll(u_case_args_____0);
static void borneo_lm(u_case_args_____0);
static void last_amix(v_case_args_____0);
static void line_amix(v_case_args_____0);
static void line_dmix(v_case_args_____0);
static void line_emix(v_case_args_____0);
static void line_fmix(v_case_args_____0);
static void line_gmix(v_case_args_____0);
static void line_gpix(v_case_args_____0);
static void line_gsix(v_case_args_____0);
static void line_hmix(v_case_args_____0);
static void line_imix(v_case_args_____0);
static void line_jmix(v_case_args_____0);
static void line_kway(v_case_args_____0);
static void line_lfar(v_case_args_____0);
static void line_nset(u_case_args_____0);
static void line_pmix(v_case_args_____0);
static void line_qmix(v_case_args_____0);
static void line_rmix(v_case_args_____0);
static void line_smap(v_case_args_____0);
static void line_sset(u_case_args_____0);
static void line_tmix(v_case_args_____0);
static void line_vmix(v_case_args_____0);
static void line_xmix(v_case_args_____0);
static void line_xpix(v_case_args_____0);
static void line_xsix(v_case_args_____0);
static void line_ymix(v_case_args_____0);
static void lock_nmix(v_case_args_____0);
static void lock_pmix(v_case_args_____0);

static const char fi_queryf[] = "i_query", fi_setf[] = "i_set",
    *const side_f[] = {
/* *INDENT-OFF* */
    fi_setf,
    fi_queryf
/* *INDENT-ON* */
};
static const struct line_type auto_line[] = {
/* *INDENT-OFF* */
#define r_express_count			0
    {	{	"i_express",
		_libx1f4i0_lxdash_e_centric,	0,
		NULL,				r_express_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SIDE_LIST
		| X1f4_E4_TEXT_LINK,
						9		},
	borneo_l_,							},
#define r_express_reach			(0 + r_express_count)
#define r_extract_count			3
    {	{	"i_extract",
		_libx1f4i0_lxdash_e_derived,	X1f4_E4_VOID,
		NULL,				r_extract_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						9		},
	bo_slmx00,							},
#define r_extract_reach \
    (r_express_reach + (r_extract_count << 1))
#define r_fit_count			1
    {	{	"i_fit",
		_libx1f4i0_lxdash_f_centric,	X1f4_E4_VOID,
		NULL,				r_fit_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SIDE_LIST
		| X1f4_E4_TEXT_LINK,		5		},
	borneo__l,							},
#define r_fit_reach			(r_extract_reach + r_fit_count)
#define r_get_count			3
    {	{	"i_get",
		_libx1f4i0_lxdash_g_derived,	X1f4_E4_VOID,
		NULL,				r_get_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						5		},
	bo_slmx00,							},
#define r_get_reach			(r_fit_reach + (r_get_count << 1))
#define r_new_count			1
    {	{	"i_new",
		_libx1f4i0_lxdash_n_forward,	X1f4_E4_VOID,
		NULL,				r_new_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		5		},
	line_nset,							},
#define r_new_reach			(r_get_reach + (r_new_count << 1))
#define r_next_count			4
    {	{	"i_next",
		_libx1f4i0_lxdash_n_centric,	X1f4_E4_MODE,
		NULL,				r_next_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						6		},
	_slmmx00x,							},
#define r_next_reach			(r_new_reach + (r_next_count << 1))
#define r_previous_count		4
    {	{	"i_previous",
		_libx1f4i0_lxdash_p_centric,	X1f4_E4_MODE,
		NULL,				r_previous_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						10		},
	_slmmx00x,							},
#define r_previous_reach \
    (r_next_reach + (r_previous_count << 1))
#define r_render_count			0
    {	{	"i_render",
		_libx1f4i0_lxdash_r_centric,	0,
		NULL,				r_render_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SIDE_LIST
		| X1f4_E4_TEXT_LINK,
						8		},
	borneo_l_,							},
#define r_render_reach			(r_previous_reach + r_render_count)
#define r_tie_count			1
    {	{	"i_tie",
		_libx1f4i0_lxdash_t_centric,	X1f4_E4_VOID,
		NULL,				r_tie_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SIDE_LIST
		| X1f4_E4_TEXT_LINK,
						5		},
	borneo__l,							}
#define r_tie_reach			(r_render_reach + r_tie_count)
/* *INDENT-ON* */
#define auto_line_count			r_tie_reach
}, ever_line[] = {
/* *INDENT-OFF* */
#define r_set_count			2
    {	{	fi_setf,
		_libx1f4i0_lxdash_s_forward,	0,
		NULL,				r_set_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		5		},
	line_sset,							}
#define r_set_reach			(0 + (r_set_count << 1))
/* *INDENT-ON* */
#define ever_line_count			r_set_reach
}, fail_line[] = {
/* *INDENT-OFF* */
#define r_add_count			3
    {	{	"i_add",
		_libx1f4i0_lxdash_a_forward,	X1f4_E4_VOID,
		NULL,				r_add_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						5		},
	borne_lmc,							},
#define r_add_reach			(0 + r_add_count)
#define r_back_count			1
    {	{	"i_back",
		_libx1f4i0_lxdash_t_forward,	X1f4_E4_CASE,
		NULL,				r_back_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo__l,							},
#define r_back_reach			(r_add_reach + r_back_count)
#define r_bind_count			3
    {	{	"i_bind",
		_libx1f4i0_lxdash_b_derived,	X1f4_E4_VOID,
		NULL,				r_bind_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borne_lmc,							},
#define r_bind_reach			(r_back_reach + r_bind_count)
#define r_case_count			3
    {	{	"i_case",
		_libx1f4i0_lxdash_c_derived,	X1f4_E4_VOID,
		NULL,				r_case_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borne_lmc,							},
#define r_case_reach			(r_bind_reach + r_case_count)
#define r_dock_count			3
    {	{	"i_dock",
		_libx1f4i0_lxdash_d_derived,	X1f4_E4_VOID,
		NULL,				r_dock_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borne_lmc,							},
#define r_dock_reach			(r_case_reach + r_dock_count)
#define r_fix_count			3
    {	{	"i_fix",
		_libx1f4i0_lxdash_f_derived,	X1f4_E4_VOID,
		NULL,				r_fix_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						5		},
	borne_lmc,							},
#define r_fix_reach			(r_dock_reach + r_fix_count)
#define r_front_count			1
    {	{	"i_front",
		_libx1f4i0_lxdash_h_forward,	X1f4_E4_CASE,
		NULL,				r_front_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	borneo__l,							},
#define r_front_reach			(r_fix_reach + r_front_count)
#define r_link_count			3
    {	{	"i_link",
		_libx1f4i0_lxdash_l_derived,	X1f4_E4_VOID,
		NULL,				r_link_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borne_lmc,							},
#define r_link_reach			(r_front_reach + r_link_count)
#define r_pick_count			2
    {	{	"i_pick",
		_libx1f4i0_lxdash_p_derived,	X1f4_E4_CASE,
		NULL,				r_pick_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo_lm,							},
#define r_pick_reach			(r_link_reach + r_pick_count)
#define r_put_count			3
    {	{	"i_put",
		_libx1f4i0_lxdash_p_forward,	X1f4_E4_VOID,
		NULL,				r_put_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						5		},
	borne_lmc,							},
#define r_put_reach			(r_pick_reach + r_put_count)
#define r_query_count			2
    {	{	fi_queryf,
		_libx1f4i0_lxdash_q_forward,	X1f4_E4_CASE,
		NULL,				r_query_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	borneo_lm,							},
#define r_query_reach			(r_put_reach + r_query_count)
#define r_replace_count			3
    {	{	"i_replace",
		_libx1f4i0_lxdash_r_derived,	X1f4_E4_VOID,
		NULL,				r_replace_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						9		},
	borne_lmc,							},
#define r_replace_reach			(r_query_reach + r_replace_count)
#define rb_pick_count			1
    {	{	"ib_pick",
		_libx1f4i0_lxdash_p_sequent,	X1f4_E4_CASE,
		NULL,				rb_pick_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	borneo__l,							},
#define rb_pick_reach			(r_replace_reach + rb_pick_count)
#define rb_query_count			1
    {	{	"ib_query",
		_libx1f4i0_lxdash_t_forward,	X1f4_E4_CASE,
		NULL,				rb_query_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						8		},
	borneo__l,							},
#define rb_query_reach			(rb_pick_reach + rb_query_count)
#define rf_pick_count			1
    {	{	"if_pick",
		_libx1f4i0_lxdash_p_pending,	X1f4_E4_CASE,
		NULL,				rf_pick_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	borneo__l,							},
#define rf_pick_reach			(rb_query_reach + rf_pick_count)
#define rf_query_count			1
    {	{	"if_query",
		_libx1f4i0_lxdash_h_forward,	X1f4_E4_CASE,
		NULL,				rf_query_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						8		},
	borneo__l,							}
#define rf_query_reach			(rf_pick_reach + rf_query_count)
/* *INDENT-ON* */
#define fail_line_count			rf_query_reach
}, slip_line[] = {
/* *INDENT-OFF* */
#define r_class_count			1
    {	{	"i_class",
		_libx1f4i0_lxdash_c_forward,	X1f4_E4_VOID,
		NULL,				r_class_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	borneo__l,							},
#define r_class_reach			(0 + r_class_count)
#define r_clear_count			1
    {	{	"i_clear",
		_libx1f4i0_lxdash_c_pending,	X1f4_E4_VOID,
		NULL,				r_clear_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	borneo__l,							},
#define r_clear_reach			(r_class_reach + r_clear_count)
#define r_copy_count			2
    {	{	"i_copy",
		_libx1f4i0_lxdash_c_logique,	X1f4_E4_VOID,
		NULL,				r_copy_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo_ll,							},
#define r_copy_reach			(r_clear_reach + r_copy_count)
#define r_delete_count			2
    {	{	"i_delete",
		_libx1f4i0_lxdash_d_logique,	X1f4_E4_VOID,
		NULL,				r_delete_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						8		},
	borneo_lm,							},
#define r_delete_reach			(r_copy_reach + r_delete_count)
#define r_down_count			2
    {	{	"i_down",
		_libx1f4i0_lxdash_d_forward,	X1f4_E4_VOID,
		NULL,				r_down_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo_lm,							},
#define r_down_reach			(r_delete_reach + r_down_count)
#define r_high_count			1
    {	{	"i_high",
		_libx1f4i0_lxdash_h_logique,	X1f4_E4_MODE,
		NULL,				r_high_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo__l,							},
#define r_high_reach			(r_down_reach + r_high_count)
#define r_id_count			2
    {	{	"i_id",
		_libx1f4i0_lxdash_i_pending,	X1f4_E4_MODE,
		NULL,				r_id_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	borneo_lm,							},
#define r_id_reach			(r_high_reach + r_id_count)
#define r_key_count			2
    {	{	"i_key",
		_libx1f4i0_lxdash_k_logique,	X1f4_E4_MODE,
		NULL,				r_key_count,
		X1f4_E4_KEEP_CALL,
						5		},
	borneo_lm,							},
#define r_key_reach			(r_id_reach + r_key_count)
#define r_low_count			1
    {	{	"i_low",
		_libx1f4i0_lxdash_l_logique,	X1f4_E4_MODE,
		NULL,				r_low_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						5		},
	borneo__l,							},
#define r_low_reach			(r_key_reach + r_low_count)
#define r_move_count			3
    {	{	"i_move",
		_libx1f4i0_lxdash_m_logique,	X1f4_E4_VOID,
		NULL,				r_move_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borne_lmm,							},
#define r_move_reach			(r_low_reach + r_move_count)
#define r_resign_count			2
    {	{	"i_resign",
		_libx1f4i0_lxdash_r_logique,	X1f4_E4_VOID,
		NULL,				r_resign_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						8		},
	borneo_lm,							},
#define r_resign_reach			(r_move_reach + r_resign_count)
#define r_short_count			1
    {	{	"i_short",
		_libx1f4i0_lxdash_s_derived,	X1f4_E4_VOID,
		NULL,				r_short_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	borneo__l,							},
#define r_short_reach			(r_resign_reach + r_short_count)
#define r_size_count			1
    {	{	"i_size",
		_libx1f4i0_lxdash_r_forward,	X1f4_E4_MODE,
		NULL,				r_size_count,
		0,				6		},
	borneo__l,							},
#define r_size_reach			(r_short_reach + r_size_count)
#define r_spin_count			3
    {	{	"i_spin",
		_libx1f4i0_lxdash_s_logique,	X1f4_E4_VOID,
		NULL,				r_spin_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borne_lmm,							},
#define r_spin_reach			(r_size_reach + r_spin_count)
#define r_swap_count			2
    {	{	"i_swap",
		_libx1f4i0_lxdash_s_sequent,	X1f4_E4_VOID,
		NULL,				r_swap_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo_ll,							},
#define r_swap_reach			(r_spin_reach + r_swap_count)
#define r_type_count			2
    {	{	"i_type",
		_libx1f4i0_lxdash_t_pending,	X1f4_E4_TEXT,
		NULL,				r_type_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo_lm,							},
#define r_type_reach			(r_swap_reach + r_type_count)
#define r_up_count			2
    {	{	"i_up",
		_libx1f4i0_lxdash_u_forward,	X1f4_E4_VOID,
		NULL,				r_up_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	borneo_lm,							}
#define r_up_reach			(r_type_reach + r_up_count)
/* *INDENT-ON* */
#define slip_line_count			r_up_reach
}, text_line[] = {
/* *INDENT-OFF* */
#define r_first_count			2
    {	{	"i_first",
		_libx1f4i0_lxdash_f_forward,	X1f4_E4_MODE,
		NULL,				r_first_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		7		},
	born_lm0x,							},
#define r_first_reach			(r_first_count << 1)
#define r_greater_count			3
    {	{	"i_greater",
		_libx1f4i0_lxdash_g_pending,	X1f4_E4_MODE,
		NULL,				r_greater_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE,
						9		},
	bo_lmm00x,							},
#define r_greater_reach \
    (r_first_reach + (r_greater_count << 1))
#define r_greaterorequal_count		3
    {	{	"i_greaterorequal",
		_libx1f4i0_lxdash_g_nearest,	X1f4_E4_MODE,
		NULL,				r_greaterorequal_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE,
						16		},
	bo_lmm00x,							},
#define r_greaterorequal_reach \
    (r_greater_reach + (r_greaterorequal_count << 1))
#define r_last_count			2
    {	{	"i_last",
		_libx1f4i0_lxdash_l_forward,	X1f4_E4_MODE,
		NULL,				r_last_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		6		},
	born_lm0x,							},
#define r_last_reach \
    (r_greaterorequal_reach + (r_last_count << 1))
#define r_less_count			3
    {	{	"i_less",
		_libx1f4i0_lxdash_l_pending,	X1f4_E4_MODE,
		NULL,				r_less_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE,
						6		},
	bo_lmm00x,							},
#define r_less_reach			(r_last_reach + (r_less_count << 1))
#define r_lessorequal_count		3
    {	{	"i_lessorequal",
		_libx1f4i0_lxdash_l_nearest,	X1f4_E4_MODE,
		NULL,				r_lessorequal_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE,
						13		},
	bo_lmm00x,							}
#define r_lessorequal_reach \
    (r_less_reach + (r_lessorequal_count << 1))
/* *INDENT-ON* */
#define text_line_count		r_lessorequal_reach
};
static const struct link_type cast_line[] = {
/* *INDENT-OFF* */
#define r_q__class			4
#define r_q__count			2
    {	{	"i_q_",
		NULL,				0,
		NULL,				r_q__count,
		X1f4_E4_TEXT_LINK,		r_q__class	},
	line_qmix,							},
#define r_q__reach			(0 + r_q__count)
#define r_q__trans			(0 + r_q__class)
#define rb_q__class			5
#define rb_q__count			1
    {	{	"ib_q_",
		NULL,				0,
		NULL,				rb_q__count,
		X1f4_E4_TEXT_LINK,		rb_q__class	},
	line_tmix,							},
#define rb_q__reach			(r_q__reach + rb_q__count)
#define rb_q__trans			(r_q__trans + rb_q__class)
#define rf_q__class			5
#define rf_q__count			1
    {	{	"if_q_",
		NULL,				0,
		NULL,				rf_q__count,
		X1f4_E4_TEXT_LINK,		rf_q__class	},
	line_hmix,							}
#define rf_q__reach			(rb_q__reach + rf_q__count)
#define rf_q__trans			(rb_q__trans + rf_q__class)
/* *INDENT-ON* */
#define cast_line_class			rf_q__trans
#define cast_line_count			rf_q__reach
#define cast_line_shift \
    sizeof(cast_line) / sizeof(struct link_type)
}, copy_line[] = {
/* *INDENT-OFF* */
#define r_a__class			4
#define r_a__count			3
    {	{	"i_a_",
		NULL,				X1f4_E4_VOID,
		NULL,				r_a__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						r_a__class	},
	line_amix,							},
#define r_a__reach			(0 + r_a__count)
#define r_a__trans			(0 + r_a__class)
#define r_f__class			4
#define r_f__count			3
    {	{	"i_f_",
		NULL,				X1f4_E4_VOID,
		NULL,				r_f__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						r_f__class	},
	line_fmix,							},
#define r_f__reach			(r_a__reach + r_f__count)
#define r_f__trans			(r_a__trans + r_f__class)
#define r_p__class			4
#define r_p__count			3
    {	{	"i_p_",
		NULL,				X1f4_E4_VOID,
		NULL,				r_p__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						r_p__class	},
	line_pmix,							},
#define r_p__reach			(r_f__reach + r_p__count)
#define r_p__trans			(r_f__trans + r_p__class)
#define r_r__class			4
#define r_r__count			3
    {	{	"i_r_",
		NULL,				X1f4_E4_VOID,
		NULL,				r_r__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						r_r__class	},
	line_rmix,							}
#define r_r__reach			(r_p__reach + r_r__count)
#define r_r__trans			(r_p__trans + r_r__class)
/* *INDENT-ON* */
#define copy_line_class			r_r__trans
#define copy_line_count			r_r__reach
#define copy_line_shift \
    sizeof(copy_line) / sizeof(struct link_type)
}, fast_line[] = {
/* *INDENT-OFF* */
#define r_e__class			4
#define r_e__count			3
    {	{	"i_e_",
		NULL,				X1f4_E4_VOID,
		NULL,				r_e__count,
		0,				r_e__class	},
	line_emix,							},
#define r_e__reach			(0 + r_e__count)
#define r_e__trans			(0 + r_e__class)
#define r_g__class			4
#define r_g__count			3
    {	{	"i_g_",
		NULL,				0,
		NULL,				r_g__count,
		0,				r_g__class	},
	line_gmix,							},
#define r_g__reach			(r_e__reach + r_g__count)
#define r_g__trans			(r_e__trans + r_g__class)
#define r_s__class			4
#define r_s__count			2
    {	{	"i_s_",
		_libx1f4i0_lxdash_s_pending,	X1f4_E4_MODE,
		NULL,				r_s__count,
		X1f4_E4_TEXT_LINK,		r_s__class	},
	line_smap,							},
#define r_s__reach			(r_g__reach + r_s__count)
#define r_s__trans			(r_g__trans + r_s__class)
#define rb_e__class			5
#define rb_e__count			2
    {	{	"ib_e_",
		NULL,				X1f4_E4_VOID,
		NULL,				rb_e__count,
		0,				rb_e__class	},
	line_vmix,							},
#define rb_e__reach			(r_s__reach + rb_e__count)
#define rb_e__trans			(r_s__trans + rb_e__class)
#define rb_g__class			5
#define rb_g__count			2
    {	{	"ib_g_",
		NULL,				0,
		NULL,				rb_g__count,
		0,				rb_g__class	},
	line_gpix,							},
#define rb_g__reach			(rb_e__reach + rb_g__count)
#define rb_g__trans			(rb_e__trans + rb_g__class)
#define rf_e__class			5
#define rf_e__count			2
    {	{	"if_e_",
		NULL,				X1f4_E4_VOID,
		NULL,				rf_e__count,
		0,				rf_e__class	},
	line_dmix,							},
#define rf_e__reach			(rb_g__reach + rf_e__count)
#define rf_e__trans			(rb_g__trans + rf_e__class)
#define rf_g__class			5
#define rf_g__count			2
    {	{	"if_g_",
		NULL,				0,
		NULL,				rf_g__count,
		0,				rf_g__class	},
	line_gsix,							},
#define rf_g__reach			(rf_e__reach + rf_g__count)
#define rf_g__trans			(rf_e__trans + rf_g__class)
#define rs_n__class			5
#define rs_n__count			4
    {	{	"is_n_",
		NULL,				X1f4_E4_MODE,
		NULL,				rs_n__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		rs_n__class	},
	lock_nmix,							},
#define rs_n__reach			(rf_g__reach + (rs_n__count << 1))
#define rs_n__trans			(rf_g__trans + rs_n__class)
#define rs_p__class			5
#define rs_p__count			4
    {	{	"is_p_",
		NULL,				X1f4_E4_MODE,
		NULL,				rs_p__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		rs_p__class	},
	lock_pmix,							}
#define rs_p__reach			(rs_n__reach + (rs_p__count << 1))
#define rs_p__trans			(rs_n__trans + rs_p__class)
/* *INDENT-ON* */
#define fast_line_class			rs_p__trans
#define fast_line_count			rs_p__reach
#define fast_line_shift \
    sizeof(fast_line) / sizeof(struct link_type)
}, land_line[] = {
/* *INDENT-OFF* */
#define r_j__count			3
    {	{	"i_j_",
		NULL,				X1f4_E4_MODE,
		NULL,				r_j__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		4		},
	line_jmix,							}
#define r_j__reach			(0 + (r_j__count << 1))
/* *INDENT-ON* */
#define land_line_class			(land_line_shift * 4)
#define land_line_count			r_j__reach
#define land_line_shift \
    sizeof(land_line) / sizeof(struct link_type)
}, long_line[] = {
/* *INDENT-OFF* */
#define r_b__count			3
    {	{	"i_b_",
		_libx1f4i0_lxdash_b_sequent,	X1f4_E4_VOID,
		NULL,				r_b__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	line_lfar,							},
#define r_b__reach			(0 + r_b__count)
#define r_c__count			3
    {	{	"i_c_",
		_libx1f4i0_lxdash_c_sequent,	X1f4_E4_VOID,
		NULL,				r_c__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	line_lfar,							},
#define r_c__reach			(r_b__reach + r_c__count)
#define r_d__count			3
    {	{	"i_d_",
		_libx1f4i0_lxdash_d_sequent,	X1f4_E4_VOID,
		NULL,				r_d__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	line_lfar,							},
#define r_d__reach			(r_c__reach + r_d__count)
#define r_l__count			3
    {	{	"i_l_",
		_libx1f4i0_lxdash_l_sequent,	X1f4_E4_VOID,
		NULL,				r_l__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	line_lfar,							}
#define r_l__reach			(r_d__reach + r_l__count)
/* *INDENT-ON* */
#define long_line_class			(long_line_shift * 4)
#define long_line_count			r_l__reach
#define long_line_shift \
    sizeof(long_line) / sizeof(struct link_type)
}, near_line[] = {
/* *INDENT-OFF* */
#define r_i__class			4
#define r_i__count			3
    {	{	"i_i_",
		NULL,				0,
		NULL,				r_i__count,
		X1f4_E4_TEXT_LINK,		r_i__class	},
	line_imix,							},
#define r_i__reach			(0 + r_i__count)
#define r_i__trans			(0 + r_i__class)
#define r_y__class			4
#define r_y__count			2
    {	{	"i_y_",
		NULL,				0,
		NULL,				r_y__count,
		X1f4_E4_TEXT_LINK,		r_y__class	},
	line_ymix,							},
#define r_y__reach			(r_i__reach + r_y__count)
#define r_y__trans			(r_i__trans + r_y__class)
/* *INDENT-ON* */
#define near_line_class			r_y__trans
#define near_line_count			r_y__reach
#define near_line_shift \
    sizeof(near_line) / sizeof(struct link_type)
}, past_line[] = {
/* *INDENT-OFF* */
#define r_x__class			4
#define r_x__count			2
    {	{	"i_x_",
		NULL,				0,
		NULL,				r_x__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						r_x__class	},
	line_xmix,							},
#define r_x__reach			(0 + r_x__count)
#define r_x__trans			(0 + r_x__class)
#define rb_x__class			5
#define rb_x__count			1
    {	{	"ib_x_",
		NULL,				X1f4_E4_VOID,
		NULL,				rb_x__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						rb_x__class	},
	line_xpix,							},
#define rb_x__reach			(r_x__reach + rb_x__count)
#define rb_x__trans			(r_x__trans + rb_x__class)
#define rf_x__class			5
#define rf_x__count			1
    {	{	"if_x_",
		NULL,				X1f4_E4_VOID,
		NULL,				rf_x__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						rf_x__class	},
	line_xsix,							}
#define rf_x__reach			(rb_x__reach + rf_x__count)
#define rf_x__trans			(rb_x__trans + rf_x__class)
/* *INDENT-ON* */
#define past_line_class			rf_x__trans
#define past_line_count			rf_x__reach
#define past_line_shift \
    sizeof(past_line) / sizeof(struct link_type)
}, seek_line[] = {
/* *INDENT-OFF* */
#define r_k__count			3
    {	{	"i_k_",
		_libx1f4i0_lxdash_k_derived,	X1f4_E4_MODE,
		NULL,				r_k__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		4		},
	line_kway,							}
#define r_k__reach			(0 + (r_k__count << 1))
/* *INDENT-ON* */
#define seek_line_class			(seek_line_shift * 4)
#define seek_line_count			r_k__reach
#define seek_line_shift \
    sizeof(seek_line) / sizeof(struct link_type)
}, skew_line[] = {
/* *INDENT-OFF* */
#define rn_a__count			3
    {	{	"in_a_",
		NULL,				0,
		NULL,				rn_a__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						5		},
	last_amix,							}
#define rn_a__reach			(0 + rn_a__count)
/* *INDENT-ON* */
#define skew_line_class			(skew_line_shift * 5)
#define skew_line_count			rn_a__reach
#define skew_line_shift \
    sizeof(skew_line) / sizeof(struct link_type)
}, spin_line[] = {
/* *INDENT-OFF* */
#define r_n__count			2
    {	{	"i_n_",
		_libx1f4i0_lxdash_n_logique,	0,
		NULL,				r_n__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	born_n_lm,							},
#define r_n__reach			(0 + r_n__count)
#define r_v__count			2
    {	{	"i_v_",
		_libx1f4i0_lxdash_v_logique,	0,
		NULL,				r_v__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	born_n_lm,							}
#define r_v__reach			(r_n__reach + r_v__count)
/* *INDENT-ON* */
#define spin_line_class			(spin_line_shift * 4)
#define spin_line_count			r_v__reach
#define spin_line_shift \
    sizeof(spin_line) / sizeof(struct link_type)
};
static const struct x1f4_postmark_type side_k[] = {
    {	MAKE_SINGLE("]", " "),	1				}
};
static const struct x1f4_2ndscope_type side_2[] = {
/* *INDENT-OFF* */
    {	X1f4_E4_POST_MARK,	NULL,
	side_k,			NULL				}
/* *INDENT-ON* */
};
static const struct x1f4_operator_type side_o[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("=", " "),  NULL,		0400,
	0,			NULL,
	X1f4_E4_BACK_LINK | X1f4_E4_E2ND_LINK | X1f4_E4_LEFT_XSET,
				1,
	NULL,			NULL					},
    {	MAKE_SINGLE("[", " "),  NULL,		0200,
	0,			NULL,
	X1f4_E4_BACK_LINK | X1f4_E4_E2ND_LINK,
				1,
	NULL,			side_2					}
/* *INDENT-ON* */
};

static int
init_line(struct lxdash_type *lxdash_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;

    if (bits & AUTOLINK_LINK) {
	lxdash_data->link_v.data = screen_data->link_v.data;
	lxdash_data->link_v.free = screen_data->link_v.free;
	lxdash_data->link_v.link = screen_data->link_v.link;
	lxdash_data->link_v.mode = screen_data->link_v.mode;
	lxdash_data->link_v.pick = screen_data->link_v.pick;
	lxdash_data->link_v.slip = screen_data->link_v.slip;
    } else {
	lxdash_data->link_v.data = NULL;
	lxdash_data->link_v.free = NULL;
	lxdash_data->link_v.link = NULL;
	lxdash_data->link_v.mode = NULL;
	lxdash_data->link_v.pick = NULL;
	lxdash_data->link_v.slip = NULL;
    }

    if (bits & CODELINK_LINK) {
	lxdash_data->link_w.data = screen_data->link_w.data;
	lxdash_data->link_w.free = screen_data->link_w.free;
	lxdash_data->link_w.link = screen_data->link_w.link;
	lxdash_data->link_w.mode = screen_data->link_w.mode;
    } else {
	lxdash_data->link_w.data = NULL;
	lxdash_data->link_w.free = _x1f4_e4_free_data;
	lxdash_data->link_w.link = _x1f4_e4_link_data;
	lxdash_data->link_w.mode = _x1f4_e4_mode_data;
    }

    if (bits & EELOOKUP_LINK) {
	lxdash_data->trap_e.eelookup_data = screen_data->trap_e.eelookup_data;
    } else {
	lxdash_data->trap_e.eelookup_data = &_x1f4_type_lookup;
    }

    if (bits & MISSBAIL_LINK) {
	lxdash_data->link_r.call = screen_data->link_r.call;
	lxdash_data->link_r.fine = screen_data->link_r.fine;
	lxdash_data->link_r.miss = screen_data->link_r.miss;
	lxdash_data->link_r.text = screen_data->link_r.text;
    } else {
	lxdash_data->link_r.call = NULL;
	lxdash_data->link_r.fine = NULL;
	lxdash_data->link_r.miss = NULL;
    }

    if (bits & RESOURCE_LINK) {
	lxdash_data->link_m.data = screen_data->link_m.data;
	lxdash_data->link_m.free = screen_data->link_m.free;
	lxdash_data->link_m.link = screen_data->link_m.link;
	lxdash_data->link_m.mode = screen_data->link_m.mode;
    } else {
	lxdash_data->link_m.data = NULL;
	lxdash_data->link_m.free = _x1f4_e4_free_data;
	lxdash_data->link_m.link = _x1f4_e4_link_data;
	lxdash_data->link_m.mode = _x1f4_e4_mode_data;
    }

    if (bits & TEXTFLAT_LINK) {
	lxdash_data->link_e.data = screen_data->link_e.data;
	lxdash_data->link_e.line = screen_data->link_e.line;
	lxdash_data->link_e.post = screen_data->link_e.post;
	lxdash_data->link_e.push = screen_data->link_e.push;
    } else {
	lxdash_data->link_e.data = NULL;
	lxdash_data->link_e.line = NULL;
	lxdash_data->link_e.post = NULL;
	lxdash_data->link_e.push = NULL;
    }

    if (bits & TRANSFER_LINK) {
	lxdash_data->link_o.fine = screen_data->link_o.fine;
    } else {
	lxdash_data->link_o.fine = NULL;
    }

    status = link_line(lxdash_data, bits, screen_data);

    return status;
}


static int
line_data(struct lxdash_type *lxdash_data, unsigned bits,
	  const struct part_type *part_data, void *data, void *text,
	  void **args, void **dana)
{
    struct lxtext_type *lxtext_data;
    const struct lxtype_type *lxtype_data;
    const struct screen_type *screen_data;
    struct x1f4_linetext_type *linetext_data;
    unsigned i;

    screen_data = part_data->screen_data;

    lxtype_data = screen_data->link_t.data;

    linetext_data = data;
    lxtext_data = text;

    lxtype_data--;

    _x1f4_type_effect(&lxtext_data->lxtype, X1f4_E4_CALL);
    lxtext_data->text = lxdash_data;

    i = screen_data->link_t.miss;
    for (; i; i--) {
	int code;
	unsigned flags;

	lxtext_data++;

	lxtype_data++;

	line_sail
	    (lxdash_data, screen_data, &linetext_data, lxtext_data,
	     lxtype_data, args, dana);

	flags = lxtype_data->flags;

	if (flags & X1f4_LX_TYPE_EXCEPT) {
	    continue;
	}

	if (1) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, fast_line_shift, fast_line);
	}
	if (bits & AUTOLINK_LINK) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, cast_line_shift, cast_line);
	}

	code = lxtype_data->code;

	if (code == X1f4_E4_BILL || code == X1f4_E4_MODE
	    || code == X1f4_E4_REAL) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, near_line_shift, near_line);
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, skew_line_shift, skew_line);
	}

	if (code < X1f4_E4_LAST || lxtype_data->lead) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, land_line_shift, land_line);
	}

	if (bits & AUTOLINK_LINK
	    || (!lxtype_data->lead && true(code != X1f4_E4_TEXT))) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, past_line_shift, past_line);
	}

	if (flags & LINK_ACCESS) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, long_line_shift, long_line);
	}
	if (0) {
	} else {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, copy_line_shift, copy_line);
	}
	if (flags & POST_ACCESS && bits & AUTOLINK_LINK) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, spin_line_shift, spin_line);
	}
	if (flags & POST_ACCESS && X1f4_E4_LAST < code && lxtype_data->lead) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, seek_line_shift, seek_line);
	}
    }

    return 0;
}


static int
line_line(struct lxdash_type *lxdash_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    lxdash_data->link_t.datatype[0].context = lxdash_data;

    lxdash_data->link_t.datatype[0].flat = _libx1f4i0_lxdash_flat_line;
    lxdash_data->link_t.datatype[0].lead = _libx1f4i0_lxdash_lead_line;
    lxdash_data->link_t.datatype[0].line = _libx1f4i0_lxdash_line_line;
    lxdash_data->link_t.datatype[0].link = _libx1f4i0_lxdash_link_line;
    lxdash_data->link_t.datatype[0].name = "index";
    lxdash_data->link_t.datatype[0].shut = _libx1f4i0_lxdash_flat_line;
    lxdash_data->link_t.datatype[0].slip = _libx1f4i0_lxdash_slip_line;
    lxdash_data->link_t.datatype[0].size = 5;
    lxdash_data->link_t.datatype[0].type = screen_data->link_l.type;

    lxdash_data->link_t.datatype[1].context = NULL;

    lxdash_data->link_t.datatype[1].flat = NULL;
    lxdash_data->link_t.datatype[1].lead = NULL;
    lxdash_data->link_t.datatype[1].line = NULL;
    lxdash_data->link_t.datatype[1].link = NULL;
    lxdash_data->link_t.datatype[1].name = NULL;
    lxdash_data->link_t.datatype[1].shut = NULL;
    lxdash_data->link_t.datatype[1].slip = NULL;
    lxdash_data->link_t.datatype[1].size = 0;
    lxdash_data->link_t.datatype[1].type = 0;

    return 0;
}


static int
line_sail(struct lxdash_type *lxdash_data,
	  const struct screen_type *screen_data,
	  struct x1f4_linetext_type **linetext,
	  struct lxtext_type *lxtext_data,
	  const struct lxtype_type *lxtype_data, void **subtext, void **dana)
{
    int code;
    struct x1f4_linetext_type *linetext_data;

    code = lxtype_data->code;

    linetext_data = *linetext;

    lxtext_data->lxtype = *lxtype_data;
    lxtext_data->text = lxdash_data;

    if (code == screen_data->link_l.type) {
	lxdash_data->link_n.node = &lxtext_data->lxtype;
    } else {
	if (code == X1f4_E4_TEXT) {
	    lxtext_data->lxtype.context = lxdash_data;

	    lxtext_data->lxtype.copy = _libx1f4i0_lxdash_copy_text;
	    lxtext_data->lxtype.free = _libx1f4i0_lxdash_free_text;
	    lxtext_data->lxtype.lead = _libx1f4i0_lxdash_lead_text;
	    lxtext_data->lxtype.move = NULL;
	    lxtext_data->lxtype.push = _libx1f4i0_lxdash_push_text;
	    lxtext_data->lxtype.slip = _libx1f4i0_lxdash_slip_text;
	}
    }

    *linetext = linetext_data;

    return 0;
}


static int
line_text(struct lxdash_type *lxdash_data, unsigned bits,
	  const struct part_type *part_data, void *data, void **args,
	  void **dana)
{
    struct x1f4_linetext_type *linetext_data;

    linetext_data = data;

    if (1) {
	_libx1f4i0_lxcall_side_line
	    (lxdash_data, bits, part_data, linetext_data, args,
	     sizeof(slip_line) / sizeof(struct line_type), slip_line);
	linetext_data += sizeof(slip_line) / sizeof(struct line_type);
    }
    if (1) {
	_libx1f4i0_lxcall_side_line
	    (lxdash_data, bits, part_data, linetext_data, args,
	     sizeof(text_line) / sizeof(struct line_type), text_line);
	linetext_data += sizeof(text_line) / sizeof(struct line_type);
    }
    if (bits & AUTOLINK_LINK) {
	_libx1f4i0_lxcall_side_line
	    (lxdash_data, bits, part_data, linetext_data, args,
	     sizeof(auto_line) / sizeof(struct line_type), auto_line);
	linetext_data += sizeof(auto_line) / sizeof(struct line_type);
	_libx1f4i0_lxcall_side_line
	    (lxdash_data, bits, part_data, linetext_data, args,
	     sizeof(fail_line) / sizeof(struct line_type), fail_line);
	linetext_data += sizeof(fail_line) / sizeof(struct line_type);
	_libx1f4i0_lxcall_side_line
	    (lxdash_data, bits, part_data, linetext_data, args,
	     sizeof(ever_line) / sizeof(struct line_type), ever_line);
	linetext_data += sizeof(ever_line) / sizeof(struct line_type);
    }
    if (1) {
	_libx1f4i0_lxcall_zero_line(linetext_data);
    }

    return 0;
}


static int
link_line(struct lxdash_type *lxdash_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;
    struct part_type part;
    unsigned args_class, args_count, line_class, line_count, main_class,
	main_count, miss, trap;
    void *data;

    args_count = 0;
    line_count = 1;
    main_count = 0;

    pick_miss(&args_class, &line_class, &main_class, bits, screen_data);

    miss = screen_data->link_t.miss;

    trap = bits & RELATION_LINK ? 1 : 0;

    {
	args_count += slip_line_count;
	line_count += sizeof(slip_line) / sizeof(struct line_type);
    }
    if (1) {
	args_count += text_line_count;
	line_count += sizeof(text_line) / sizeof(struct line_type);
    }
    if (bits & AUTOLINK_LINK) {
	args_count += auto_line_count;
	line_count += sizeof(auto_line) / sizeof(struct line_type);
	args_count += fail_line_count;
	line_count += sizeof(fail_line) / sizeof(struct line_type);
	args_count += ever_line_count;
	line_count += sizeof(ever_line) / sizeof(struct line_type);
    }

    status = lxdash_data->link_w.link
	(lxdash_data->link_w.data, &data,
	 sizeof(struct lxtext_type) * (1 + miss) + fm_size(away)
	 + (args_class + args_count) * sizeof(int)
	 + (line_class + line_count) * sizeof(struct x1f4_linetext_type)
	 + (sizeof(struct tide_type) + sizeof(struct x1f4_operator_type *))
	 * fb_size() + sizeof(struct x1f4_operator_type *)
	 + ((sizeof(struct x1f4_ftaa_type) + sizeof(struct x1f4_ftca_type))
	    * (miss + 1) + sizeof(struct x1f4_fpdetail_type)) * trap
	 + main_class + main_count);
    if (status) {
	status = LINK_ERROR;
    } else {
	struct x1f4_fpdetail_type *fpdetail_data;
	void *args, *dana, *side, *tile, *text;

	tile = (struct x1f4_linetext_type *) data + line_class;
	dana = (struct x1f4_linetext_type *) tile + line_count;

	if (trap) {
	    fpdetail_data = (void *)
		((struct x1f4_linetext_type *) tile + line_count);
	    part.ftaa_data = (void *) (fpdetail_data + 1);
	    part.ftca_data = (void *) (part.ftaa_data + miss + 1);
	    fpdetail_data->bits1 = X1f4_E4_TYPE_LIST | X1f4_E4_XSET_LIST;
	    fpdetail_data->ftaa_data = part.ftaa_data;
	    fpdetail_data->ftca_data = part.ftca_data;
	    dana = part.ftca_data + miss + 1;
	} else {
	    fpdetail_data = NULL;
	    part.ftaa_data = NULL;
	    part.ftca_data = NULL;
	    dana = (struct x1f4_linetext_type *) tile + line_count;
	}

	/*
	 * lxmiss and lxtext records required together
	 */
	text = (struct lxmiss_type *) dana + 1;
	side = (struct lxtext_type *) text + 1 + miss;
	side = (struct tide_type *) side + fb_size();
	args = (struct x1f4_operator_type **) side + fb_size() + 1;
	dana = (int *) args + args_class + args_count;

	lxdash_data->link_f.data = data;
	lxdash_data->link_f.side = side;
	lxdash_data->link_f.text = text;

	((struct lxmiss_type *) text - 1)->data.miss = miss;

	part.screen_data = screen_data;

	line_data(lxdash_data, bits, &part, data, text, &args, &dana);
	line_text(lxdash_data, bits, &part, tile, &args, &dana);
	_libx1f4i0_lxcall_line_side(side, data, side_o, side_f, fb_size());

	line_line(lxdash_data, bits, screen_data);

	if (trap) {
	    part.ftaa_data->linetext_data = NULL;
	    part.ftaa_data->type = X1f4_E4_VOID;
	    part.ftca_data->linetext_data = NULL;
	    part.ftca_data->type = X1f4_E4_VOID;

	    x1f4_post_mxpath
		(screen_data->link_y.linetrap_data->fpaccess, fi_queryf, 7,
		 fpdetail_data);
	}

	if (status) {
	    lxdash_data->link_w.free(lxdash_data->link_w.data, data);
	} else {
	}
    }

    return status;
}


static int
pick_miss(unsigned *args, unsigned *line, unsigned *pick, unsigned bits,
	  const struct screen_type *screen_data)
{
    const struct lxtype_type *lxtype_data;
    unsigned args_count = 0, line_count = 0, i, main_count = 0;

    lxtype_data = screen_data->link_t.data;
    lxtype_data--;

    i = screen_data->link_t.miss;
    for (; i; i--) {
	int code;
	unsigned deck, flags;

	lxtype_data++;

	flags = lxtype_data->flags;

	if (flags & X1f4_LX_TYPE_EXCEPT) {
	    continue;
	}

	deck = lxtype_data->size + 1;

	if (1) {
	    args_count += fast_line_count;
	    line_count += fast_line_shift;
	    main_count += deck * fast_line_shift + fast_line_class;
	}
	if (bits & AUTOLINK_LINK) {
	    args_count += cast_line_count;
	    line_count += cast_line_shift;
	    main_count += deck * cast_line_shift + cast_line_class;
	}

	code = lxtype_data->code;

	if (code == X1f4_E4_BILL || code == X1f4_E4_MODE
	    || code == X1f4_E4_REAL) {
	    args_count += near_line_count;
	    line_count += near_line_shift;
	    main_count += deck * near_line_shift + near_line_class;
	    args_count += skew_line_count;
	    line_count += skew_line_shift;
	    main_count += deck * skew_line_shift + skew_line_class;
	    if (flags & FLAT_REFLEX) {
	    } else {
		args_count += l_i_type_post;
	    }
	}

	if (code < X1f4_E4_LAST || lxtype_data->lead) {
	    args_count += land_line_count;
	    line_count += land_line_shift;
	    main_count += deck * land_line_shift + land_line_class;
	}

	if (bits & AUTOLINK_LINK
	    || (!lxtype_data->lead && true(code != X1f4_E4_TEXT))) {
	    args_count += past_line_count;
	    line_count += past_line_shift;
	    main_count += deck * past_line_shift + past_line_class;
	}

	if (flags & FLAT_REFLEX) {
	} else {
	    args_count += l_e_type_post;
	    args_count += l_g_type_post;
	    args_count += lbe_type_post;
	    args_count += lbg_type_post;
	    args_count += lfe_type_post;
	    args_count += lfg_type_post;
	}
	if (flags & LINK_ACCESS) {
	    args_count += long_line_count;
	    line_count += long_line_shift;
	    main_count += deck * long_line_shift + long_line_class;
	}
	if (0) {
	} else {
	    args_count += copy_line_count;
	    line_count += copy_line_shift;
	    main_count += deck * copy_line_shift + copy_line_class;
	}
	if (flags & POST_ACCESS && bits & AUTOLINK_LINK) {
	    args_count += spin_line_count;
	    line_count += spin_line_shift;
	    main_count += deck * spin_line_shift + spin_line_class;
	}
	if (flags & POST_ACCESS && X1f4_E4_LAST < code && lxtype_data->lead) {
	    args_count += seek_line_count;
	    line_count += seek_line_shift;
	    main_count += deck * seek_line_shift + seek_line_class;
	}
    }

    *args = args_count;
    *line = line_count;
    *pick = main_count;

    return 0;
}


static void
_slmmx00x(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_SLIP;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
bo_lmm00x(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = 0;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
bo_slmx00(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_SLIP;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;
    *line++ = 0;

    *args = line;
}


static void
born_lm0x(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
born_n_lm(v_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.type = nodetype_data->code;
}


static void
borne_lmc(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_CASE;

    *args = line;
}


static void
borne_lmm(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
borneo__l(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;

    *args = line;
}


static void
borneo_l_(u_case_args_____1)
{
    linetext_data->function.type = screen(screen)->link_l.type;
}


static void
borneo_ll(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_l.type;

    *args = line;
}


static void
borneo_lm(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
last_amix(v_case_args_____1)
{
    int *line, type;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = type;

    *args = line;

    if (type == X1f4_E4_REAL) {
	linetext_data->function.function = _libx1f4i0_lxdash_a_break_r;
    } else {
	if (type == X1f4_E4_MODE) {
	    linetext_data->function.function = _libx1f4i0_lxdash_a_break_m;
	} else {
	    if (1) {
		linetext_data->function.function = _libx1f4i0_lxdash_a_break_b;
	    } else {
	    }
	}
    }

    linetext_data->function.type = type;
}


static void
line_amix(v_case_args_____1)
{
    int *line, type;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = type;

    *args = line;

    if (nodetype_data->copy || may_include(nodetype_data)) {
	linetext_data->function.function = _libx1f4i0_lxdash_a_class_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_a_class_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_a_class_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_a_class_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_a_class_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_a_class_b;
			} else {
			}
		    }
		}
	    }
	}
    }
}


static void
line_dmix(v_case_args_____1)
{
    int *line, type;
    unsigned flags;

    flags = nodetype_data->flags;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = type;
    *line++ = screen(screen)->link_l.type;
    if (flags & FLAT_REFLEX) {
    } else {
	*line++ = X1f4_E4_POST_XSET;
	*line++ = 0;
    }

    *args = line;

    if (flags & FLAT_REFLEX) {
	linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;
    } else {
	linetext_data->function.flags =
	    X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK;
    }

    if (nodetype_data->push) {
	linetext_data->function.function = _libx1f4i0_lxdash_efclass_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_efclass_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_efclass_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_efclass_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_efclass_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_efclass_b;
			} else {
			}
		    }
		}
	    }
	}
    }

    linetext_data->function.type = type;
}


static void
line_emix(v_case_args_____1)
{
    int *line, type;
    unsigned flags;

    flags = nodetype_data->flags;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = type;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    if (flags & FLAT_REFLEX) {
    } else {
	*line++ = X1f4_E4_POST_XSET;
	*line++ = 0;
	*line++ = 0;
    }

    *args = line;

    if (flags & FLAT_REFLEX) {
	linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;
    } else {
	linetext_data->function.flags =
	    X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK;
    }

    if (nodetype_data->push) {
	linetext_data->function.function = _libx1f4i0_lxdash_e_class_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_e_class_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_e_class_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_e_class_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_e_class_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_e_class_b;
			} else {
			}
		    }
		}
	    }
	}
    }

    linetext_data->function.type = type;
}


static void
line_fmix(v_case_args_____1)
{
    int *line, type;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = type;

    *args = line;

    if (nodetype_data->copy || may_include(nodetype_data)) {
	linetext_data->function.function = _libx1f4i0_lxdash_f_class_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_f_class_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_f_class_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_f_class_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_f_class_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_f_class_b;
			} else {
			}
		    }
		}
	    }
	}
    }
}


static void
line_gmix(v_case_args_____1)
{
    int *line, type;
    struct x1f4_ftaa_type *ftaa_data;
    unsigned flags;

    flags = nodetype_data->flags;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = type;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    if (flags & FLAT_REFLEX) {
    } else {
	*line++ = X1f4_E4_POST_XSET;
	*line++ = 0;
	*line++ = 0;
    }

    *args = line;

    if (flags & FLAT_REFLEX) {
	linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;
    } else {
	linetext_data->function.flags =
	    X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK;
    }

    ftaa_data = part(screen)->ftaa_data;

    if (nodetype_data->push) {
	linetext_data->function.function = _libx1f4i0_lxdash_g_class_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_g_class_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_g_class_t;
	    } else {
		ftaa_data = NULL;

		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_g_class_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_g_class_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_g_class_b;
			} else {
			}
		    }
		}
	    }
	}
    }

    if (ftaa_data) {
	ftaa_data->linetext_data = linetext_data;
	ftaa_data->type = type;
	part(screen)->ftaa_data = ftaa_data + 1;
    }

    linetext_data->function.type = type;
}


static void
line_gpix(v_case_args_____1)
{
    int *line, type;
    unsigned flags;

    flags = nodetype_data->flags;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = type;
    *line++ = screen(screen)->link_l.type;
    if (flags & FLAT_REFLEX) {
    } else {
	*line++ = X1f4_E4_POST_XSET;
	*line++ = 0;
    }

    *args = line;

    if (flags & FLAT_REFLEX) {
	linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;
    } else {
	linetext_data->function.flags =
	    X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK;
    }

    if (nodetype_data->push) {
	linetext_data->function.function = _libx1f4i0_lxdash_gbclass_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_gbclass_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_gbclass_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_gbclass_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_gbclass_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_gbclass_b;
			} else {
			}
		    }
		}
	    }
	}
    }

    linetext_data->function.type = type;
}


static void
line_gsix(v_case_args_____1)
{
    int *line, type;
    unsigned flags;

    flags = nodetype_data->flags;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = type;
    *line++ = screen(screen)->link_l.type;
    if (flags & FLAT_REFLEX) {
    } else {
	*line++ = X1f4_E4_POST_XSET;
	*line++ = 0;
    }

    *args = line;

    if (flags & FLAT_REFLEX) {
	linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;
    } else {
	linetext_data->function.flags =
	    X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK;
    }

    if (nodetype_data->push) {
	linetext_data->function.function = _libx1f4i0_lxdash_gfclass_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_gfclass_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_gfclass_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_gfclass_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_gfclass_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_gfclass_b;
			} else {
			}
		    }
		}
	    }
	}
    }

    linetext_data->function.type = type;
}


static void
line_hmix(v_case_args_____1)
{
    int *line, type;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;

    *args = line;

    type = nodetype_data->code;

    if (nodetype_data->lead) {
	linetext_data->function.function = _libx1f4i0_lxdash_qfclass_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_qfclass_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_qfclass_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_qfclass_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_qfclass_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_qfclass_b;
			} else {
			}
		    }
		}
	    }
	}
    }

    linetext_data->function.type = type;
}


static void
line_imix(v_case_args_____1)
{
    int *line, type;
    struct x1f4_ftaa_type *ftaa_data;
    unsigned flags;

    flags = nodetype_data->flags;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = type;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    if (flags & FLAT_REFLEX) {
    } else {
	*line++ = X1f4_E4_POST_XSET;
	*line++ = 0;
	*line++ = 0;
    }

    *args = line;

    if (flags & FLAT_REFLEX) {
	linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;
    } else {
	linetext_data->function.flags =
	    X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK;
    }

    ftaa_data = part(screen)->ftaa_data;

    if (type == X1f4_E4_REAL) {
	linetext_data->function.function = _libx1f4i0_lxdash_i_class_r;
    } else {
	if (type == X1f4_E4_MODE) {
	    linetext_data->function.function = _libx1f4i0_lxdash_i_class_m;
	} else {
	    if (type == X1f4_E4_BILL) {
		linetext_data->function.function = _libx1f4i0_lxdash_i_class_b;
	    } else {
	    }
	}
    }

    if (ftaa_data) {
	ftaa_data->linetext_data = linetext_data;
	ftaa_data->type = type;
	part(screen)->ftaa_data = ftaa_data + 1;
    }

    linetext_data->function.type = type;
}


static void
line_jmix(v_case_args_____1)
{
    int *line, type;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = type;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;
    *line++ = 0;

    *args = line;

    if (nodetype_data->lead) {
	linetext_data->function.function = _libx1f4i0_lxdash_j_class_v;
    } else {
	if (0) {
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_j_class_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_j_class_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_j_class_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_j_class_b;
			} else {
			}
		    }
		}
	    }
	}
    }
}


static void
line_kway(v_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = nodetype_data->code;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;
    *line++ = 0;

    *args = line;
}


static void
line_lfar(v_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = nodetype_data->code;

    *args = line;
}


static void
line_nset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
line_pmix(v_case_args_____1)
{
    int *line, type;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = type;

    *args = line;

    if (nodetype_data->copy || may_include(nodetype_data)) {
	linetext_data->function.function = _libx1f4i0_lxdash_p_class_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_p_class_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_p_class_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_p_class_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_p_class_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_p_class_b;
			} else {
			}
		    }
		}
	    }
	}
    }
}


static void
line_qmix(v_case_args_____1)
{
    int *line, type;
    struct x1f4_ftca_type *ftca_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    type = nodetype_data->code;

    ftca_data = part(screen)->ftca_data;

    if (nodetype_data->lead) {
	linetext_data->function.function = _libx1f4i0_lxdash_q_class_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_q_class_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_q_class_t;
	    } else {
		ftca_data = NULL;

		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_q_class_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_q_class_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_q_class_b;
			} else {
			}
		    }
		}
	    }
	}
    }

    if (ftca_data) {
	ftca_data->linetext_data = linetext_data;
	ftca_data->type = type;
	part(screen)->ftca_data = ftca_data + 1;
    }

    linetext_data->function.type = type;
}


static void
line_rmix(v_case_args_____1)
{
    int *line, type;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = type;

    *args = line;

    if (nodetype_data->copy || may_include(nodetype_data)) {
	linetext_data->function.function = _libx1f4i0_lxdash_r_class_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_r_class_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_r_class_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_r_class_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_r_class_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_r_class_b;
			} else {
			}
		    }
		}
	    }
	}
    }
}


static void
line_smap(v_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_sset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;

    *args = line;

    linetext_data->function.type = screen(screen)->link_l.type;
}


static void
line_tmix(v_case_args_____1)
{
    int *line, type;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;

    *args = line;

    type = nodetype_data->code;

    if (nodetype_data->lead) {
	linetext_data->function.function = _libx1f4i0_lxdash_qbclass_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_qbclass_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_qbclass_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_qbclass_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_qbclass_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_qbclass_b;
			} else {
			}
		    }
		}
	    }
	}
    }

    linetext_data->function.type = type;
}


static void
line_vmix(v_case_args_____1)
{
    int *line, type;
    unsigned flags;

    flags = nodetype_data->flags;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = type;
    *line++ = screen(screen)->link_l.type;
    if (flags & FLAT_REFLEX) {
    } else {
	*line++ = X1f4_E4_POST_XSET;
	*line++ = 0;
    }

    *args = line;

    if (flags & FLAT_REFLEX) {
	linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;
    } else {
	linetext_data->function.flags =
	    X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK;
    }

    if (nodetype_data->push) {
	linetext_data->function.function = _libx1f4i0_lxdash_ebclass_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_ebclass_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_ebclass_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_ebclass_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_ebclass_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_ebclass_b;
			} else {
			}
		    }
		}
	    }
	}
    }

    linetext_data->function.type = type;
}


static void
line_xmix(v_case_args_____1)
{
    int *line, type;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.type = type;

    if (nodetype_data->push) {
	linetext_data->function.function = _libx1f4i0_lxdash_x_class_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_x_class_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_x_class_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_x_class_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_x_class_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_x_class_b;
			} else {
			}
		    }
		}
	    }
	}
    }
}


static void
line_xpix(v_case_args_____1)
{
    int *line, type;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;

    *args = line;

    linetext_data->function.type = nodetype_data->code;

    if (nodetype_data->push) {
	linetext_data->function.function = _libx1f4i0_lxdash_xbclass_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_xbclass_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_xbclass_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_xbclass_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_xbclass_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_xbclass_b;
			} else {
			}
		    }
		}
	    }
	}
    }
}


static void
line_xsix(v_case_args_____1)
{
    int *line, type;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;

    *args = line;

    linetext_data->function.type = nodetype_data->code;

    if (nodetype_data->push) {
	linetext_data->function.function = _libx1f4i0_lxdash_xfclass_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_xfclass_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_xfclass_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_xfclass_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_xfclass_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_xfclass_b;
			} else {
			}
		    }
		}
	    }
	}
    }
}


static void
line_ymix(v_case_args_____1)
{
    int *line, type;
    struct x1f4_ftca_type *ftca_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    type = nodetype_data->code;

    ftca_data = part(screen)->ftca_data;

    if (type == X1f4_E4_REAL) {
	linetext_data->function.function = _libx1f4i0_lxdash_y_class_r;
    } else {
	if (type == X1f4_E4_MODE) {
	    linetext_data->function.function = _libx1f4i0_lxdash_y_class_m;
	} else {
	    if (type == X1f4_E4_BILL) {
		linetext_data->function.function = _libx1f4i0_lxdash_y_class_b;
	    } else {
	    }
	}
    }

    if (ftca_data) {
	ftca_data->linetext_data = linetext_data;
	ftca_data->type = type;
	part(screen)->ftca_data = ftca_data + 1;
    }

    linetext_data->function.type = type;
}


static void
lock_nmix(v_case_args_____1)
{
    int *line, type;
    unsigned flags;

    flags = nodetype_data->flags;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = type;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    if (flags & FLAT_REFLEX) {
	*line++ = 0;
    } else {
	*line++ = X1f4_E4_POST_XSET;
    }
    {
	*line++ = 0;
	*line++ = 0;
	*line++ = X1f4_E4_POST_XSET;
    }

    *args = line;

    if (nodetype_data->push) {
	linetext_data->function.function = _libx1f4i0_lxdash_n_point_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_n_point_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_n_point_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_n_point_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_n_point_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_n_point_b;
			} else {
			}
		    }
		}
	    }
	}
    }
}


static void
lock_pmix(v_case_args_____1)
{
    int *line, type;
    unsigned flags;

    flags = nodetype_data->flags;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = type;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    if (flags & FLAT_REFLEX) {
	*line++ = 0;
    } else {
	*line++ = X1f4_E4_POST_XSET;
    }
    {
	*line++ = 0;
	*line++ = 0;
	*line++ = X1f4_E4_POST_XSET;
    }

    *args = line;

    if (nodetype_data->push) {
	linetext_data->function.function = _libx1f4i0_lxdash_p_point_v;
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = _libx1f4i0_lxdash_p_point_u;
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = _libx1f4i0_lxdash_p_point_t;
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function =
			_libx1f4i0_lxdash_p_point_r;
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function =
			    _libx1f4i0_lxdash_p_point_m;
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function =
				_libx1f4i0_lxdash_p_point_b;
			} else {
			}
		    }
		}
	    }
	}
    }
}


int
x1f4_init_lxdash(void **lxdash, unsigned bits,
		 const struct screen_type *screen_data)
{
    int (*link) (void *, void **, unsigned), status;
    void *line, *text;

    if (bits & CODELINK_LINK) {
	link = screen_data->link_w.link;
	text = screen_data->link_w.data;
    } else {
	link = _x1f4_e4_link_data;
	text = (void *) 0;
    }

    status = link(text, &line, sizeof(struct lxdash_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	status = init_line(line, bits, screen_data);
	if (status) {
	    if (bits & CODELINK_LINK) {
		screen_data->link_w.free(text, line);
	    } else {
		_x1f4_e4_free_data(text, line);
	    }
	} else {
	    *lxdash = line;
	}
    }

    return status;
}
