/*
 * lxdash-a.1.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdash-defs.h>
#include <lxdash-types.h>

static int fini_line(struct lxdash_type *);

static int
fini_line(struct lxdash_type *lxdash_data)
{
    int (*free) (void *, void *), status;
    void *data;

    status = 0;

    data = lxdash_data->link_w.data;
    free = lxdash_data->link_w.free;

    if (free(data, lxdash_data->link_f.data)) {
	status = FREE_ERROR;
    }

    if (free(data, lxdash_data)) {
	status = FREE_ERROR;
    }

    return status;
}


int
x1f4_fini_lxdash(void **lxdash)
{
    return fini_line(*lxdash);
}
