/*
 * lxdash-a.c.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxcall.h>
#include <lxlead.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define break_cycles			0

#define lxdash(line) \
    ((struct lxdash_type *) (line))

int
_libx1f4i0_lxdash_side_line(void *subtext, void *dxdash)
{
    int status;
    unsigned call;

    call = lock_exline(dxdash)->call;
    if (call ^ 1) {
	int (*miss) (void *, struct x1f4_nodelink_type **,
		     struct x1f4_nodelink_type *);

	lock_exline(dxdash)->call = call - 1;

	miss = lxdash(subtext)->link_r.miss;
	if (miss) {
	    status = miss
		(lxdash(subtext)->link_r.text, NULL, lock_excase(dxdash));
	} else {
	    status = x1f4_mind_lxlead(NULL, dxdash);
	}
    } else {
	int excess;

	lock_exline(dxdash)->call = break_cycles;

	status = _libx1f4i0_lxdash_null_line(subtext, NULL, dxdash);

	excess = _libx1f4i0_lxdash_fine_line(subtext, dxdash);
	if (excess) {
	    status = _libx1f4i0_lxcall_land_slip(excess, status);
	}
    }

    return status;
}
