/*
 * lxdash-a.u.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <cl.h>
#include <copy.h>
#include <e4.h>
#include <lxlead.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>
#include <nt.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define club(miss)			((unsigned *) (miss))

#define becca(context) \
    ((void **) (context))
#define scope(context) \
    (becca((context)) + 2)
#define track(context) \
    (becca((context)) + 3)
#define frame(context) \
    (becca((context)) + 4)
#define class(context) \
    (becca((context)) + 5)

int
_libx1f4i0_lxdash_copy_link(void *context, void *line, const void *data)
{
    int status;
    const struct effect_type *effect_data;
    struct effect_type *effect_line;
    struct lxdash_type *lxdash_data;

    lxdash_data = *becca(context);

    effect_data = data;
    effect_line = line;

    effect_line->link = effect_data->link;
    effect_line->mode = effect_data->mode;
    effect_line->type = effect_data->type;

    do {
	unsigned link;

	link = effect_data->link;

	if (~link) {
	    struct lxtext_type *lxtext_link;

	    lxtext_link =
		(struct lxtext_type *) lxdash_data->link_f.text + link;

	    if (x1f4_pull_lxlead
		(*track(context), &effect_line->fxdata, &effect_data->fxdata,
		 &status, *frame(context),
		 (struct x1f4_caselink_type **) class(context),
		 &lxtext_link->lxtype, lock_excase(*scope(context)))) {
		if (status) {
		} else {
		}

		break;
	    }
	}

	status = 0;

	{
#if defined copy_trap
	    copy_trap(&effect_line->fxdata, &effect_data->fxdata);
#else
	    unsigned type;

	    type = effect_data->type;

	    copy_miss(&effect_line->fxdata, type, &effect_data->fxdata);
#endif				/* copy_trap */
	}
    } while (0);

    return status;

}
