/*
 * lxdash-e.5.c
 * Copyright (C) 2008-2011, 2013, 2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdash-inter.h>
#include <lxdash-types.h>
#include <trans.h>

extern const char *const x1f4_c1_empty_string;

int
_libx1f4i0_lxdash_free_text(void *subtext, void *text,
			    struct excase_type **excase,
			    const struct excase_type *excase_data)
{
    int status;

    if (text == x1f4_c1_empty_string) {
	status = 0;
    } else {
	struct lxdash_type *lxdash_data;

	lxdash_data = subtext;

	status = lxdash_data->link_m.free(lxdash_data->link_m.data, text);
	if (status) {
	    status = _libx1f4i0_lxdash_stat_free(lxdash_data, 0);
	}
    }

    return status;
}
