/*
 * lxdash-e.e.c
 * Copyright (C) 2008-2013, 2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <exerrors.h>
#include <lxlead.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>
#include <tcvset.h>

#define lxdash(line) \
    ((struct lxdash_type *) (line))

#define tccase(vset) \
    ((struct x1f4_tccase_type *) (vset))

int
x1f4_pick_lxdash(void *subtext, void *dxdash, struct excase_type **excase,
		 const struct excase_type *excase_data)
{
    int status;
    unsigned call;

    call = lock_exline(dxdash)->call;

    if (call) {
	call--;
	if (call) {
	    status = tccase(lock_exline(dxdash)->text)->miss
		(&lock_exline(dxdash)->pset, &lock_exline(dxdash)->text,
		 excase_data, (void *) &lxdash(subtext)->link_m);
	    if (status) {
		status = X1f4_EX_CRITICAL;
	    } else {
		int (*fine) (void *, struct x1f4_nodelink_type **,
			     struct x1f4_nodelink_type *);

		lock_exline(dxdash)->call = call;

		fine = lxdash(subtext)->link_r.fine;
		if (fine) {
		    status = fine
			(lxdash(subtext)->link_r.text, excase,
			 lock_excase(dxdash));
		} else {
		    x1f4_side_lxlead(excase, dxdash);
		}
	    }
	} else {
	    status = 0;
	    if (lock_excase(dxdash)->slip) {
	    } else {
		lock_exline(dxdash)->call = 0;
		lock_excase(dxdash)->slip = *excase;
		*excase = lock_excase(dxdash);
	    }
	}
    } else {
	status = 0;
    }

    return status;
}
