/*
 * lxdash-e.y.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <copy.h>
#include <e4.h>
#include <exerrors.h>
#include <lxcall.h>
#include <lxcast.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

#define lxdash(lxdash) \
    ((struct lxdash_type *) (lxdash))

int
_libx1f4i0_lxdash_post_data(void *lxdash, void *output, void *data)
{
    int status;

    do {
	const struct effect_type *effect_data;
	struct lxtext_type *lxtext_data;
	unsigned link;
	void *cast;

	effect_data = data;

	link = effect_data->link;

	if (~link) {
	    lxtext_data = lxdash(lxdash)->link_f.text;
	    lxtext_data += link;
	    if (lxtext_data->lxtype.lead) {
		status = _libx1f4i0_lxcall_post_node
		    (&lxdash(lxdash)->link_v, &lxdash(lxdash)->link_e,
		     &lxtext_data->lxtype, effect_data->type,
		     (char *) &effect_data->fxdata - 8, output);
		if (1) {
		    break;
		}
	    } else {
#if 0
		if (lxtext_data->lxtype.code == X1f4_E4_TEXT) {
		    status = _libx1f4i0_lxcall_post_text
			(&lxdash(lxdash)->link_v, &lxdash(lxdash)->link_m,
			 &lxdash(lxdash)->link_e,
			 (void *) &effect_data->fxdata, output);
		    if (1) {
			break;
		    }
		}
#endif				/* 0 */
	    }
	}

	if (0) {
	} else {
	    unsigned type;

	    type = effect_data->type;

	    if (X1f4_E4_LAST < type && type < X1f4_E4_CALL) {
		status = _libx1f4i0_lxdash_stat_lead(lxdash, type);
	    } else {
		status = lxdash(lxdash)->link_v.link
		    (lxdash(lxdash)->link_v.data, &cast,
		     sizeof(struct x1f4_dxcast_type));
		if (status) {
		    status = _libx1f4i0_lxdash_stat_link(lxdash);
		} else {
		    struct x1f4_dxcast_type *dxcast_data;

		    dxcast_data = cast;

		    l_USER(cast, output);

		    dxcast_data->call = 0;
		    dxcast_data->type = type;

		    copy_miss(&dxcast_data->data, type, &effect_data->fxdata);
		}
	    }
	}
    } while (0);

    return status;
}
