/*
 * lxdash-f.s.c
 * Copyright (C) 2008-2011, 2013-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcall.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define __LOOSE_LINK__			1
#define __TIGHT_LINK__			2

#define __LINK_LOGIC__			__LOOSE_LINK__

#define ____LINK_LOGIC__		__LINK_LOGIC__

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_LINE(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_s_forward(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_text;
    struct lxdash_type *lxdash_data;

    dxdash_text = I_LINE(input[1]);

    lxdash_data = context;

    status = _libx1f4i0_lxcall_near_node
	(&lxdash_data->link_v, &lxdash_data->link_e,
	 lxdash_data->link_t.datatype, I_LINE(input[0]));
    if (status) {
    } else {
	lock_exline(dxdash_text)->call++;

	l_LINE(dxdash_text, input[0]);
	l_LINE(dxdash_text, output);
    }

    return status;
}
