/*
 * lxdash-p.p.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>
#include <retain.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxdash_p_pending(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct lxdash_type *lxdash_data;
    void *dash, *data;

    dxdash_data = I_LINE(input[0]);

    lxdash_data = context;

    dash = dxdash_data->dash;

    status = _libx1f4i0_lead_lxfset(dash, &data);
    if (status) {
	status = _libx1f4i0_lxdash_stat_line(context, 0, status);
    } else {
	status = _libx1f4i0_lxdash_post_data(lxdash_data, output, data);
	if (status) {
	} else {
#if __RETAIN_OBJECT_DATA__
# error not considered
#else
	    struct effect_type *effect_data;
	    unsigned link;

	    effect_data = data;

	    link = effect_data->link;
	    if (~link) {
		struct lxtext_type *lxtext_data;

		lxtext_data = lxdash_data->link_f.text;
		lxtext_data += link;
		if (lxtext_data->lxtype.lead) {
		    status = lxtext_data->lxtype.free
			(lxtext_data->lxtype.context,
			 I_USER(&effect_data->fxdata), NULL,
			 lock_excase(dxdash_data));
		} else {
		}
	    }

	    if (status) {
	    } else {
		effect_data->link = ~0;

		status = _libx1f4i0_mind_lxfset(dash);
		if (status) {
		    status =
			_libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
		} else {
		    dxdash_data->size--;
		}
	    }
#endif				/* __RETAIN_OBJECT_DATA__ */
	}
    }

    return status;
}
