/*
 * lxdash-r.q.b.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_REAL(t)			(*((X1f4_E4_C_REAL *) (t)))

#define l_REAL(e, output) \
    {									      \
	X1f4_E4_C_REAL *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define lxtext(delete)			((struct lxtext_type *) (delete))

int
_libx1f4i0_lxdash_qbclass_r(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    void *data;

    dxdash_data = I_LINE(input[0]);

    status = _libx1f4i0_ever_lxfset(dxdash_data->dash, &data);
    if (status) {
	status = _libx1f4i0_lxdash_stat_line
	    (lxtext(context)->text, 0, status);
    } else {
	struct effect_type *effect_data;
	unsigned type;

	effect_data = data;

	type = effect_data->type;
	if (type != X1f4_E4_REAL) {
	    struct lxtext_type *lxtext_data;

	    lxtext_data = context;

	    status = _libx1f4i0_lxdash_stat_ends
		(lxtext_data->text, 1, type, lxtext_data->lxtype.code);
	} else {
	    l_REAL(I_REAL(&effect_data->fxdata), output);
	}
    }

    return status;
}
