/*
 * lxdash-s.l.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <fd.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

int
_libx1f4i0_lxdash_l_sequent(void *context, void *output, void **input)
{
    int status;

    do {
	struct dxdash_type *dxdash_data;
	struct effect_type effect;
	struct lxdash_type *lxdash_data;
	struct lxtext_type *lxtext_data;
	void *data;

	lxtext_data = context;

	dxdash_data = I_LINE(input[0]);

	lxdash_data = lxtext_data->text;

	effect.mode = I_MODE(input[1]);

	status = x1f4_post_lxfset(dxdash_data->dash, &effect, &data);
	if (status) {
	    if (status ^ X1f4_BQFSET_EVER_MATCH) {
		status = _libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
	    } else {
		status = _libx1f4i0_lxdash_stat_post(lxdash_data, effect.mode);
	    }
	} else {
	    struct effect_type *effect_data;
	    unsigned link, type;

	    type = lxtext_data->lxtype.code;

	    effect_data = data;

	    effect_data->type = type;

	    effect_data->mode = effect.mode;

	    link = lxtext_data
		- ((struct lxtext_type *) lxdash_data->link_f.text);

	    effect_data->link = link;

	    status = lxtext_data->lxtype.node
		(lxtext_data->lxtype.context, (void **) &effect_data->fxdata,
		 I_USER(input[2]), lock_excase(dxdash_data));
	    if (status) {
		effect_data->link = ~0;

		_libx1f4i0_cast_lxfset(dxdash_data->dash, &effect);
	    } else {
		dxdash_data->size++;
	    }
	}
    } while (0);

    return status;
}
