/*
 * lxdash-t.g.b.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <d_fset.h>
#include <e4.h>
#include <lxcall.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_TEXT(e, output) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_gbclass_t(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct lxdash_type *lxdash_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    lxdash_data = lxtext_data->text;

    dxdash_data = I_LINE(input[1]);

    status = _libx1f4i0_ever_lxfset(dxdash_data->dash, &data);
    if (status) {
	status = _libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
    } else {
	struct effect_type *effect_data;
	unsigned type;

	effect_data = data;

	type = effect_data->type;
	if (type != X1f4_E4_TEXT) {
	    status = _libx1f4i0_lxdash_stat_ends
		(lxdash_data, 1, type, lxtext_data->lxtype.code);
	} else {
	    X1f4_E4_C_TEXT post;

	    post = I_TEXT(&effect_data->fxdata);

	    status = _libx1f4i0_lxcall_swap_text
		(&lxdash_data->link_v, &lxdash_data->link_m,
		 &lxdash_data->link_e, *input, post, strlen(post) + 1);
	    if (status) {
	    } else {
		l_TEXT(I_TEXT(*input), output);
	    }
	}
    }

    return status;
}
