/*
 * lxdash-v.f.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <e4.h>
#include <fd.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_f_class_v(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    struct lxtext_type *lxtext_data, *lxtext_link;
    void *data, *side;

    dxdash_data = I_LINE(input[0]);

    lxtext_data = context;

    lxdash_data = lxtext_data->text;

    if (0) {
    } else {
	do {
	    struct effect_type *effect_data;

	    lxtext_link = lxdash_data->link_f.text;

	    status = lxtext_data->lxtype.copy
		(lxtext_data->lxtype.context, NULL, &side,
		 I_USER(input[2]), lock_excase(dxdash_data));
	    if (status) {
		if (1) {
		    break;
		}
	    }

	    effect.mode = I_MODE(input[1]);

	    status = x1f4_post_lxfset(dxdash_data->dash, &effect, &data);
	    if (status) {
		if (status ^ X1f4_BQFSET_EVER_MATCH) {
		    status =
			_libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);

		    lxtext_data->lxtype.free
			(lxtext_data->lxtype.context, side,
			 NULL, lock_excase(dxdash_data));

		    break;
		} else {
		    unsigned link;

		    status = 0;

		    effect_data = data;

		    link = effect_data->link;

		    if (~link) {
			int (*free) (void *, void *, struct excase_type **,
				     const struct excase_type *);
			struct lxtext_type *lxtext_slip;

			lxtext_slip = lxtext_link + link;

			free = lxtext_slip->lxtype.free;
			if (free) {
			    status = free
				(lxtext_slip->lxtype.context,
				 I_USER(&effect_data->fxdata), NULL,
				 lock_excase(dxdash_data));
			}
		    }
		}
	    } else {
		effect_data = data;

		dxdash_data->size++;

		effect_data->mode = effect.mode;
	    }

	    {
		unsigned link;

		link = lxtext_data - lxtext_link;

		effect_data->link = link;

		l_USER(side, &effect_data->fxdata);

		effect_data->type = lxtext_data->lxtype.code;
	    }
	} while (0);
    }

    return status;
}
