/*
 * lxdata-l.e.c
 * Copyright (C) 2008-2011, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))

int
_libx1f4i0_lxdata_e_logique(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_MODE head, tail;
	struct dxdata_type *dxdata_data;
	unsigned size;

	dxdata_data = I_DATA(input[0]);

	size = dxdata_data->length;

	head = I_MODE(input[1]);

	if (head < 0) {
	    if ((X1f4_E4_C_MODE) size < -head) {
		status = _libx1f4i0_lxdata_stat_deck(context, size, -head);
		if (1) {
		    break;
		}
	    } else {
		head = size + head;
	    }
	} else {
	    if (head < size) {
	    } else {
		status = _libx1f4i0_lxdata_stat_deck(context, size, head);
		if (1) {
		    break;
		}
	    }
	}

	tail = I_MODE(input[2]);

	if (tail < 0) {
	    if ((X1f4_E4_C_MODE) size < -tail) {
		status = _libx1f4i0_lxdata_stat_deck(context, size, -tail);
		if (1) {
		    break;
		}
	    } else {
		tail = size + tail;
	    }
	} else {
	    if (tail < size) {
	    } else {
		status = _libx1f4i0_lxdata_stat_deck(context, size, tail);
		if (1) {
		    break;
		}
	    }
	}

	status = _libx1f4i0_lxdata_clip_long(context, dxdata_data, head, tail);
    } while (0);

    return status;
}
