/*
 * lxdecq-u.h.c
 * Copyright (C) 2008-2010, 2013, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <f_list.h>
#include <lxcall.h>
#include <lxdecq-inter.h>
#include <lxdecq-types.h>

#define I_LIST(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

#define lxtext(delete)			((struct lxtext_type *) (delete))

int
_libx1f4i0_lxdecq_qfclass_v(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;
    struct lxdecq_type *lxdecq_data;
    struct lxtext_type *lxtext_data;

    lxtext_data = context;

    lxdecq_data = lxtext_data->text;

    dxlist_data = I_LIST(input[0]);
    if (0) {
    } else {
	if (!dxlist_data->size) {
	    status = _libx1f4i0_lxdecq_stat_null(lxdecq_data);
	} else {
	    void *data;

	    status = _libx1f4i0_lead_dllist(dxlist_data->list, &data);
	    if (status) {
		status = _libx1f4i0_lxdecq_stat_list(lxdecq_data, 0, status);
	    } else {
		struct lxtext_type *lxtext_data;
		unsigned type;

		lxtext_data = context;

		type = byte(data)[0] << 030 | byte(data)[1] << 020
		    | byte(data)[2] << 010 | byte(data)[3];
		if (type != lxtext_data->lxtype.code) {
		    status = _libx1f4i0_lxdecq_stat_type
			(lxdecq_data, 0, type, lxtext_data->lxtype.code);
		} else {
		    status = _libx1f4i0_lxcall_pick_node
			(&lxdecq_data->link_v, &lxdecq_data->link_e,
			 &lxtext_data->lxtype, I_USER(byte(data) + 8), output);
		}
	    }
	}
    }

    return status;
}
