/*
 * lxline-d.s.c
 * Copyright (C) 2008-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <l_note.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxline_s_derived(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    void *data;

    dxline_data = I_LINE(input[0]);

    lxline_data = context;

    status = _libx1f4i0_ever_sfnote(dxline_data->line, &data);
    if (status) {
	status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
    } else {
	do {
	    unsigned link;

	    link = byte(data)[4] << 030 | byte(data)[5] << 020
		| byte(data)[6] << 010 | byte(data)[7];
	    if (~link) {
		int (*free) (void *, void *, struct excase_type **,
			     const struct excase_type *);
		struct lxtext_type *lxtext_link;

		lxtext_link =
		    ((struct lxtext_type *) lxline_data->link_f.text) + link;

		free = lxtext_link->lxtype.free;
		if (free) {
		    status = free
			(lxtext_link->lxtype.context,
			 I_USER(byte(data) + 8), NULL,
			 lock_excase(dxline_data));
		    if (status) {
			break;
		    }
		}
	    }

	    status = _libx1f4i0_slip_sfnote(dxline_data->line);
	    if (status) {
		status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
	    } else {
		dxline_data->size--;
	    }
	} while (0);
    }

    return status;
}
