/*
 * lxline-l.s.c
 * Copyright (C) 2008-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <fd.h>
#include <l_note.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxline_s_logique(void *context, void *output, void **input)
{
    X1f4_E4_C_TEXT fail;
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    void *data;

    dxline_data = I_LINE(input[0]);

    lxline_data = context;

    fail = I_TEXT(input[1]);

    status = _libx1f4i0_find_sfnote(dxline_data->line, fail, &data);
    if (status) {
	X1f4_E4_C_TEXT land;
	void *text;

	land = I_TEXT(input[2]);

	status = _libx1f4i0_find_sfnote(dxline_data->line, land, &text);
	if (status) {
	    struct fxdata_type fxdata;
	    unsigned char byte_slip__i_;

	    byte_slip__i_ = byte(data)[0];
	    byte(data)[0] = byte(text)[0];
	    byte(text)[0] = byte_slip__i_;
	    byte_slip__i_ = byte(data)[1];
	    byte(data)[1] = byte(text)[1];
	    byte(text)[1] = byte_slip__i_;
	    byte_slip__i_ = byte(data)[2];
	    byte(data)[2] = byte(text)[2];
	    byte(text)[2] = byte_slip__i_;
	    byte_slip__i_ = byte(data)[3];
	    byte(data)[3] = byte(text)[3];
	    byte(text)[3] = byte_slip__i_;
	    byte_slip__i_ = byte(data)[4];
	    byte(data)[4] = byte(text)[4];
	    byte(text)[4] = byte_slip__i_;
	    byte_slip__i_ = byte(data)[5];
	    byte(data)[5] = byte(text)[5];
	    byte(text)[5] = byte_slip__i_;
	    byte_slip__i_ = byte(data)[6];
	    byte(data)[6] = byte(text)[6];
	    byte(text)[6] = byte_slip__i_;
	    byte_slip__i_ = byte(data)[7];
	    byte(data)[7] = byte(text)[7];
	    byte(text)[7] = byte_slip__i_;

	    fxdata = *(struct fxdata_type *) (byte(data) + 8);
	    *(struct fxdata_type *) (byte(data) + 8) =
		*(struct fxdata_type *) (byte(text) + 8);
	    *(struct fxdata_type *) (byte(text) + 8) = fxdata;

	    status = 0;
	} else {
	    status = _libx1f4i0_lxline_stat_miss(lxline_data, land);
	}
    } else {
	status = _libx1f4i0_lxline_stat_miss(lxline_data, fail);
    }

    return status;
}
