/*
 * lxline-n.s.1.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <copy.h>
#include <e4.h>
#include <fd.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxdata.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxline_s1nearest(void *context, void *output, void **input)
{
    int status;
    const char *lift;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct x1f4_dxdata_type *dxdata_data;
    unsigned size;
    void *data;

    dxline_data = I_LINE(input[1]);

    dxdata_data = I_DATA(input[2]);

    lxline_data = context;

    status = _libx1f4i0_llxq_sfnote
	(dxline_data->line, dxdata_data->string, &data, &lift, &size);
    if (status) {
	unsigned call, type;

	type = byte(data)[0] << 030 | byte(data)[1] << 020
	    | byte(data)[2] << 010 | byte(data)[3];
	call = *((struct x1f4_function_type *)
		 ((void **) input[-1])[X1f4_E4_RENDITION])->args;
	if (type != call) {
	    status = _libx1f4i0_lxline_stat_trip
		(lxline_data, lift, size, type, call);
	} else {
	    status = x1f4_kate_lxdata
		(lxline_data->link_l.data, dxdata_data, 1, size);
	    if (status) {
	    } else {
		unsigned link;

		memcpy(dxdata_data->string, lift, size);

		link = byte(data)[4] << 030 | byte(data)[5] << 020
		    | byte(data)[6] << 010 | byte(data)[7];

		l_MODE(1, output);

		do {
		    struct fxdata_type fxdata;

		    if (~link) {
			struct lxtext_type *lxtext_data;

			lxtext_data = lxline_data->link_f.text;
			lxtext_data += link;
			if (lxtext_data->lxtype.lead
			    && lxtext_data->lxtype.slip) {
			    status = _libx1f4i0_lxcall_land_node
				(&lxline_data->link_v, &lxline_data->link_e,
				 &lxtext_data->lxtype, I_USER(byte(data) + 8),
				 input[0]);
			    if (1) {
				break;
			    }
			}
		    }

		    status = 0;

		    fxdata = *(struct fxdata_type *) (byte(data) + 8);

		    copy_miss(*input, type, &fxdata);
		} while (0);
	    }
	}
    } else {
	if (0) {
	} else {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	}
    }

    return status;
}
