/*
 * lxline-t.x.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_TEXT(e, output) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxline_x_class_t(void *context, void *output, void **input)
{
    X1f4_E4_C_TEXT fail;
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    lxline_data = lxtext_data->text;

    dxline_data = I_LINE(input[0]);

    fail = I_TEXT(input[1]);

    status = _libx1f4i0_find_sfnote(dxline_data->line, fail, &data);
    if (status) {
	unsigned type;

	type = byte(data)[0] << 030 | byte(data)[1] << 020
	    | byte(data)[2] << 010 | byte(data)[3];
	if (type != X1f4_E4_TEXT) {
	    status = _libx1f4i0_lxline_stat_type
		(lxline_data, fail, type, lxtext_data->lxtype.code);
	} else {
	    status = _libx1f4i0_lxcall_pick_text
		(&lxline_data->link_v, &lxline_data->link_m,
		 &lxline_data->link_e, byte(data) + 8);
	    if (status) {
	    } else {
		l_TEXT(I_TEXT(byte(data) + 8), output);

		status = _libx1f4i0_pass_sfnote(dxline_data->line, fail);
		if (status) {
		    byte(data)[4] = ~0 >> 030;
		    byte(data)[5] = ~0 >> 020;
		    byte(data)[6] = ~0 >> 010;
		    byte(data)[7] = ~0 >> 000;

		    status =
			_libx1f4i0_lxline_stat_line(lxline_data, 0, status);
		} else {
		    dxline_data->size--;
		}
	    }
	}
    } else {
	status = _libx1f4i0_lxline_stat_miss(lxline_data, fail);
    }

    return status;
}
