/*
 * lxline-u.s-c.s.c
 * Copyright (C) 2008-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxdata.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxline_s_order_u(void *context, void *output, void **input)
{
    int status;
    const char *lift;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct lxtext_type *lxtext_data;
    struct x1f4_dxdata_type *dxdata_data;
    unsigned size;
    void *data;

    lxtext_data = context;

    dxline_data = I_LINE(input[1]);

    dxdata_data = I_DATA(input[2]);

    lxline_data = lxtext_data->text;

    status = _libx1f4i0_llxq_sfnote
	(dxline_data->line, dxdata_data->string, &data, &lift, &size);
    if (status) {
	unsigned type;

	type = byte(data)[0] << 030 | byte(data)[1] << 020
	    | byte(data)[2] << 010 | byte(data)[3];
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxline_stat_trip
		(lxtext_data->text, lift, size, type,
		 lxtext_data->lxtype.code);
	} else {
	    status = x1f4_kate_lxdata
		(lxline_data->link_l.data, dxdata_data, 1, size);
	    if (status) {
	    } else {
		memcpy(dxdata_data->string, lift, size);

		l_USER(I_USER(byte(data) + 8), input[0]);
		l_MODE(1, output);
	    }
	}
    } else {
	if (0) {
	} else {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	}
    }

    return status;
}
