/*
 * lxlist-a.t.c
 * Copyright (C) 2008-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l_list.h>
#include <lxfset.h>
#include <lxlead.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define dxlist(list) \
    ((struct dxlist_type *) (list))
#define lxlist(list) \
    ((struct lxlist_type *) (list))

int
_libx1f4i0_lxlist_late_list(void *subtext, void *late, void *copy,
			    const void *list)
{
    int status;
    struct lxlist_type *lxlist_data;

    lxlist_data = subtext;

    if (1) {
	void *becca[6];

	becca[0] = subtext;
	becca[2] = late;

	status = x1f4_init_lxfset(becca + 3);
	if (status) {
	    status = _libx1f4i0_lxlist_stat_link(lxlist_data);
	} else {
	    int excess;
	    void **node, *record;

	    status = x1f4_post_lxfset(becca[3], (void *) &list, &record);
	    if (status) {
		status = _libx1f4i0_lxlist_stat_link(lxlist_data);
	    } else {
		node = record;

		node[0] = (void *) list;
		node[1] = late;

		becca[4] = &lxlist_data->link_m;
		becca[5] = NULL;

		status = _libx1f4i0_line_l4list
		    (dxlist(copy)->list, dxlist(list)->list,
		     _libx1f4i0_lxlist_copy_link, _libx1f4i0_lxlist_free_link,
		     becca);
		if (status) {
		    status = _libx1f4i0_lxlist_stat_list
			(lxlist_data, 0, status);

		    x1f4_lose_lxlead(becca[5], &lxlist_data->link_m);
		} else {
		    dxlist(copy)->size = dxlist(list)->size;

		    status = x1f4_beta_lxlead
			(becca[3], becca[5], &lxlist_data->link_m);
		}
	    }

	    excess = x1f4_fini_lxfset(becca + 3);
	    if (excess) {
		status = _libx1f4i0_lxlist_stat_free(lxlist_data, status);
	    }
	}
    }

    return status;
}
