/*
 * lxpoll-inter.h
 * Copyright (C) 2008-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxpoll_inter_H__
#define __LIBx1f4_lxpoll_inter_H__

#include <dt.h>
#include <e4.h>
#include <lxpoll-types.h>
#include <lxwide.h>
#include <nt.h>

#define _libx1f4i0_lxpoll_bset_poll	x1f4_bset_lxpoll
#define _libx1f4i0_lxpoll_cfix_poll	x1f4_cfix_lxpoll
#define _libx1f4i0_lxpoll_clip_poll	x1f4_clip_lxpoll
#define _libx1f4i0_lxpoll_copy_poll	x1f4_copy_lxpoll
#define _libx1f4i0_lxpoll_dset_poll	x1f4_dset_lxpoll
#define _libx1f4i0_lxpoll_dump_poll	x1f4_dump_lxpoll
#define _libx1f4i0_lxpoll_fini_poll	x1f4_fini_lxpoll
#define _libx1f4i0_lxpoll_flat_poll	x1f4_flat_lxpoll
#define _libx1f4i0_lxpoll_free_poll	x1f4_free_lxpoll
#define _libx1f4i0_lxpoll_fset_poll	x1f4_fset_lxpoll
#define _libx1f4i0_lxpoll_hash_poll	x1f4_hash_lxpoll
#define _libx1f4i0_lxpoll_init_poll	x1f4_init_lxpoll
#define _libx1f4i0_lxpoll_jack_poll	x1f4_jack_lxpoll
#define _libx1f4i0_lxpoll_lead_poll	x1f4_lead_lxpoll
#define _libx1f4i0_lxpoll_line_poll	x1f4_line_lxpoll
#define _libx1f4i0_lxpoll_link_poll	x1f4_link_lxpoll
#define _libx1f4i0_lxpoll_move_poll	x1f4_move_lxpoll
#define _libx1f4i0_lxpoll_near_poll	x1f4_near_lxpoll
#define _libx1f4i0_lxpoll_node_poll	x1f4_node_lxpoll
#define _libx1f4i0_lxpoll_pick_poll	x1f4_pick_lxpoll
#define _libx1f4i0_lxpoll_push_poll	x1f4_push_lxpoll
#define _libx1f4i0_lxpoll_seek_poll	x1f4_seek_lxpoll
#define _libx1f4i0_lxpoll_shut_poll	x1f4_shut_lxpoll
#define _libx1f4i0_lxpoll_slip_poll	x1f4_slip_lxpoll
#define _libx1f4i0_lxpoll_tile_poll	x1f4_tile_lxpoll
#define _libx1f4i0_lxpoll_type_poll	x1f4_type_lxpoll

extern int _libx1f4i0_lxpoll_bset_poll
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxpoll_c_logique(void *, void *, void **);
extern int _libx1f4i0_lxpoll_cfix_poll(void *, unsigned, void *);
extern int _libx1f4i0_lxpoll_clip_poll
    (const void *, struct x1f4_nodetype_type **, int *);
extern int _libx1f4i0_lxpoll_copy_poll
    (void *, void *, void **, const void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpoll_dset_poll
    (void *, const struct x1f4_datatype_type **);
extern int _libx1f4i0_lxpoll_dump_poll(void *, struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpoll_e_logique(void *, void *, void **);
extern int _libx1f4i0_lxpoll_even_list
    (const struct x1f4_function_type *,
     const struct x1f4_function_type *, unsigned, void ***,
     struct lxpoll_type *);
extern int _libx1f4i0_lxpoll_fare_date(void *, void *);
extern int _libx1f4i0_lxpoll_fare_file(void *, void *);
extern int _libx1f4i0_lxpoll_fare_line(void *, void *);
extern int _libx1f4i0_lxpoll_fare_trap(void *, void *);
extern int _libx1f4i0_lxpoll_fast_line
    (const struct x1f4_linetext_type *, const struct x1f4_function_type *,
     unsigned, void ***, struct dxpoll_type *, struct lxpoll_type *);
extern int _libx1f4i0_lxpoll_fast_poll(void *, void *);
extern int _libx1f4i0_lxpoll_fine_poll(void *, void *);
extern int _libx1f4i0_lxpoll_flat_file(void *, void *);
extern int _libx1f4i0_lxpoll_flat_line(void *, void *);
extern int _libx1f4i0_lxpoll_fini_poll(void **);
extern int _libx1f4i0_lxpoll_flat_poll(void *, void **);
extern int _libx1f4i0_lxpoll_free_file
    (struct lxpoll_type *, void *, struct dxpoll_type *);
extern int _libx1f4i0_lxpoll_free_line
    (struct lxpoll_type *, struct x1f4_nodelink_type **, void **,
     struct dxpoll_type *);
extern int _libx1f4i0_lxpoll_free_poll
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpoll_free_text
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpoll_fset_poll
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxpoll_hash_poll
    (void *, struct x1f4_nodelink_type **, struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpoll_heap_poll
    (void *, struct x1f4_nodelink_type **, void *);
extern int _libx1f4i0_lxpoll_init_poll
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxpoll_jack_poll
    (void *, const struct x1f4_datatype_type *);
extern int _libx1f4i0_lxpoll_lead_poll(void *, void **);
extern int _libx1f4i0_lxpoll_line_poll(void *, void **);
extern int _libx1f4i0_lxpoll_link_poll(void *, void **);
extern int _libx1f4i0_lxpoll_move_poll
    (void *, void *, const struct x1f4_nodelink_type *,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpoll_near_poll(void *);
extern int _libx1f4i0_lxpoll_node_cast
    (struct lxpoll_type *, void **, void *, struct dxpoll_type *, void ***);
extern int _libx1f4i0_lxpoll_node_date
    (struct lxpoll_type *, void **, void *, struct dxpoll_type *, void ***);
extern int _libx1f4i0_lxpoll_node_file
    (struct lxpoll_type *, void **, void *, struct dxpoll_type *, void ***);
extern int _libx1f4i0_lxpoll_node_poll
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpoll_node_text
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpoll_null_poll
    (void *, struct x1f4_nodelink_type **, void *);
extern int _libx1f4i0_lxpoll_p1forward(void *, void *, void **);
extern int _libx1f4i0_lxpoll_p_forward(void *, void *, void **);
extern int _libx1f4i0_lxpoll_p_logique(void *, void *, void **);
extern int _libx1f4i0_lxpoll_pick_poll
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpoll_push_poll
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpoll_q1logique(void *, void *, void **);
extern int _libx1f4i0_lxpoll_q_logique(void *, void *, void **);
extern int _libx1f4i0_lxpoll_r_forward(void *, void *, void **);
extern int _libx1f4i0_lxpoll_r_logique(void *, void *, void **);
extern int _libx1f4i0_lxpoll_s1logique(void *, void *, void **);
extern int _libx1f4i0_lxpoll_s_forward(void *, void *, void **);
extern int _libx1f4i0_lxpoll_s_logique(void *, void *, void **);
extern int _libx1f4i0_lxpoll_s_pending(void *, void *, void **);
extern int _libx1f4i0_lxpoll_seek_poll(const void *);
extern int _libx1f4i0_lxpoll_shut_poll(void *, void **);
extern int _libx1f4i0_lxpoll_side_poll(void *, void *);
extern int _libx1f4i0_lxpoll_slip_poll(void *, void **);
extern int _libx1f4i0_lxpoll_stat_busy(void *);
extern int _libx1f4i0_lxpoll_stat_call(void *);
extern int _libx1f4i0_lxpoll_stat_data(void *);
extern int _libx1f4i0_lxpoll_stat_ever(void *);
extern int _libx1f4i0_lxpoll_stat_file(void *);
extern int _libx1f4i0_lxpoll_stat_flat(void *, int);
extern int _libx1f4i0_lxpoll_stat_free(void *, int);
extern int _libx1f4i0_lxpoll_stat_link(void *);
extern int _libx1f4i0_lxpoll_stat_long(void *);
extern int _libx1f4i0_lxpoll_stat_miss(void *);
extern int _libx1f4i0_lxpoll_stat_poll(void *, int, void *, int);
extern int _libx1f4i0_lxpoll_stat_push(void *);
extern int _libx1f4i0_lxpoll_stat_read(void *);
extern int _libx1f4i0_lxpoll_stat_slip(void *);
extern int _libx1f4i0_lxpoll_stat_trip(void *);
extern int _libx1f4i0_lxpoll_stat_user(void *, int);
extern int _libx1f4i0_lxpoll_text_list
    (const struct x1f4_linetext_type *, const struct x1f4_function_type *,
     void **, struct dxpoll_type *, struct x1f4_nodelink_type **,
     struct lxpoll_type *);
extern int _libx1f4i0_lxpoll_tile_poll
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxpoll_type_list
    (const struct x1f4_linetext_type *, const struct x1f4_function_type *,
     void **, struct dxpoll_type *, struct lxpoll_type *);
extern int _libx1f4i0_lxpoll_type_poll(struct x1f4_nodetype_type *, int);
extern int _libx1f4i0_lxpoll_w1logique(void *, void *, void **);
extern int _libx1f4i0_lxpoll_w_logique(void *, void *, void **);

#endif				/* __LIBx1f4_lxpoll_inter_H__ */
