/*
 * lxtrap-i.x.c
 * Copyright (C) 2011-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <af.h>
#include <copy.h>
#include <e4.h>
#include <lxcall.h>
#include <lxcast.h>
#include <lxtrap-inter.h>
#include <lxtrap-types.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

int
_libx1f4i0_lxtrap_lock_port(int land, void *report, void *missed, int type,
			    struct lxtrap_type *lxtrap_data)
{
    int status = 0;
    const struct lxtype_type *lxtype_data;
    unsigned i;

    lxtype_data = lxtrap_data->link_t.data;

    i = lxtrap_data->link_t.miss;
    for (; i; i--) {
	if (lxtype_data->type == land) {
	    break;
	} else {
	    lxtype_data++;
	}
    }

    do {
	if (type == X1f4_E4_CASE) {
	    struct x1f4_dxcast_type *dxcast_data;

	    dxcast_data = I_USER(missed);
	    type = dxcast_data->type;
	    if (land != type) {
		status = _libx1f4i0_lxtrap_stat_miss(lxtrap_data, land, type);
		if (1) {
		    break;
		}
	    } else {
		missed = &dxcast_data->data;
	    }
	}

	if (i) {
	    if (lxtype_data->slip) {
		if (lxtype_data->lead) {
		    struct x1f4_nodetype_type nodetype;

		    nodetype.lead = lxtype_data->lead;
		    nodetype.slip = lxtype_data->slip;

		    nodetype.context = lxtype_data->text;

		    status = _libx1f4i0_lxcall_land_node
			(&lxtrap_data->link_v, &lxtrap_data->link_e, &nodetype,
			 I_USER(missed), report);
		    if (1) {
			break;
		    }
		}
	    }
	} else {
	    if (X1f4_E4_CALL < type) {
		if (1) {
		    struct x1f4_nodetype_type nodetype;

		    nodetype.lead = _x1f4_lead_effect;
		    nodetype.slip = _x1f4_slip_effect;

		    status = _libx1f4i0_lxcall_land_node
			(&lxtrap_data->link_v, &lxtrap_data->link_e, &nodetype,
			 I_USER(missed), report);
		    if (1) {
			break;
		    }
		}
	    }
	}

	copy_miss(report, land, missed);
    } while (0);

    return status;
}
