/*
 * lxxsxx-a.b.c
 * Copyright (C) 2008, 2009, 2010, 2011, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <exerrors.h>
#include <lxport-types.h>
#include <nl.h>
#include <tcvset.h>

#define tccase(vset) \
    ((struct x1f4_tccase_type *) (vset))

int
x1f4_copy_xsport(void *subtext, void *bppp, void **copy, const void *port,
		 const struct x1f4_nodelink_type *nodelink_data)
{
    int status;
    void *slip;

    slip = (void *) port;

    status = tccase(lock_exlist(slip)->text)->push
	(&lock_exlist(slip)->pset, &lock_exlist(slip)->text, nodelink_data,
	 (void *) &((struct lxport_type *) subtext)->link_m);
    if (status) {
	status = X1f4_EX_CRITICAL;
    } else {
	*copy = slip;

	lock_exlist(slip)->call++;
    }

    return status;
}
