/*
 * run.v.c
 * Copyright (C) 2006-2010, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

int
x1f4_vprint_run(void *data, int (*this) (void *, const char *, unsigned),
		int c, unsigned run)
{
    int status = 0;
    unsigned come[4], e;

    e = c;

    e |= e << 010;
    e |= e << 020;
#if 4 < SIZEOF_UNSIGNED
    e |= e << 040;
#endif				/* 4 < SIZEOF_UNSIGNED */

    come[0] = e;
    come[1] = e;
    come[2] = e;
    come[3] = e;

    while (run & ~15) {
	run -= 16;
	status = this(data, (char *) come, 16);
	if (status) {
	    run = 0;
	}
    }
    if (run) {
	status = this(data, (char *) come, run);
    }

    return status;
}
